


;TYPES (contents of ram address)
;	<blank>	number of bits is hardware dependent	
;	ptr	10 bit address pointer
;	flag	16 bit value 0 is false, nonzero is true
;	uint	16 bit unsigned value 0..65535
;	int	16 bit signed value -32768..32767
;	ulong	32 bit unsigned value 0..4294967295
;	long	32 bit signed value -2147483648..2147483647
;	double	64 bit signed value -1.8E19..1.8E19

;PARAMETER	VALUE	TYPE	FUNCTION
; local hardware
MinusOne	0FFFFh
MinusTwo	0FFFEh
MinusFour	0FFFCh

SetTP0		03Ch
ClrTP0		03Dh
SetTP1		03Eh
ClrTP1		03Fh
OptJprs		03Fh

ExtData			060h
ExtAdd			068h
ExtStat			06Ah
StartExtRead		06Ch
StartExtWrite		06Dh
ExtAddrInc		06Eh
HTimerBits		070h
ErrorLED		079h
LocalLEDs		07Ah
LEDMode			07Bh
USTimer			07Ch
FPGASPICS		07Dh
FPGASPIData		07Eh

; FPGA serial flash commands
FlashReadCom		003h
FlashReadIDCom		0ABh
FlashWritePageCom	002h
FlashEraseSecCom	00D8h
FlashWriteEnaCom	006h
FlashWriteDisCom	004h
FlashReadStatusCom	005h

FlashIdle		0AA01h
FlashRead		0AA02h
FlashWrite		0AA03h
FlashErase		0AA04h
FlashID			0AA05h

; WACMMMSSINNNNNNN = lbp16 command bits

LBPCountMask		0007Fh
LBPIncAddrMask		00080h
LBPSizeMask		00300h
LBPMemSpaceMask		01C00h
LBPControlMask		02000h
LBPContAndMemMask	03C00h
LBPAddrThereMask	04000h
LBPWriteMask		08000h
LBPMemSpace1Sel		00400h
LBPMemSpace2Sel		00800h
LBPMemSpace3Sel		00C00h
LBPMemSpace4Sel		01000h
LBPMemSpace5Sel		01400h
LBPMemSpace6Sel		01800h
LBPMemSpace7Sel		01C00h

; MEM Space  WTTT TTTT AAAA AAAA 
; 01 register 02 control 8E eeprom 8F flash 	
; W is writeable, T is type A is access types (bit 0 = byte bit 1 = 16 bit)
; so for example 0x06 means 16 bit and 32 bit operations allowed 
; MEM Ranges EEEE EPPP PPSS SSSS (E AND P only apply to flash)
; E is erase block size P is Page size S is address range (2^E, 2^P, 2^S)

LBPMemSpace0		08104h	; type 0x01 32 bit RW access (hm2)
LBPMemRanges0		00010h	; 2^16 address range

LBPMemSpace1		00000h	; type 0x00 unused
LBPMemRanges1		00000h	; 

LBPMemSpace2		00000h	; type 0x00 unused
LBPMemRanges2		00000h	;

LBPMemSpace3		08F04h	; type 0x0F 32 bit RW access
LBPMemRanges3		08200h	; address range discovered, 256 byte page 
				; 64k byte erase

LBPMemSpace4		08202h	; type 0x02 16 bit RW access
LBPMemRanges4		00003h	; 2^3 address range

LBPMemSpace5		00000h	; type 0x00 unused
LBPMemRanges5		00000h	; 

LBPMemSpace6		08202h	; type 0x02 16 bit RW access
LBPMemRanges6		00004h	; 2^4 address range

LBPMemSpace7		00202h	; type 0x02 16 bit RO access
LBPMemRanges7		00004h	; 2^4 address range

;RecvBufSize		(sendbuf-recvbuf)*2	; in bytes

; hardware addresses

ICapDataPort		020h
ICapClkPort		021h
ICapRWPort		022h

CRCGenData	023h
CRCGenClear	024h

RXUData		030h
RXUFrameBytes	031h
RXUBitRateL	032h
RXUBitRateH	033h
RXUModeRegL	034h
RXUModeRegH	035h

TXUData		036h
TXUFrameBytes	037h
TXUBitRateL	038h
TXUBitRateH	039h
TXUModeRegL	03Ah
TXUModeRegH	03Bh

FrameCountMask	01Fh
RXErrorMask	0C000h
RXCountMask	03FFFh
RXBuffErrMask	00020h
BitRate115dot2KLow	04B7h	; for 100 MHz
BitRate115Dot2KHigh	0000h
BitRate2dot5MLow	6666h	; for 100 MHz
BitRate2Dot5MHigh	0000h	


RAMBegin	128          
RAMEnd		2047

zeroloc		128	%ptr	
oneloc		129	%ptr	
twoloc		130	%ptr
threeloc	131	%ptr
fourloc		132	%ptr
fiveloc		133	%ptr
sixloc		134	%ptr
sevenloc	135	%ptr		
eightloc	136	%ptr
sixteenloc	137	%ptr

lowbytemask	138
highbytemask	139

; WACMMMSSINNNNNNN = lbp16 command bits

mem0space	143
mem1space	144
mem2space	145
mem3space	146
mem4space	147
mem5space	148
mem6space	149
mem7space	150

lbpsize2	151	%ptr
lbpsize4	152	%ptr

loopiloc	153	%ptr
loopjloc	154	%ptr
loopkloc	155	%ptr

temp0		158	
temp1		159	

recvfcount	170
recvpktsize	171
recvpktloop	172

sendpktsize	180
sendpktloop	181
sendpkttype	182

maxtxpktsize	184
maxrxpktsize	185
sendbuflimit	186
recvbuflimit	187

delay0		190
delay1		191
test0		192
htimermask	193
htimerstate	194
oldhtimerstate	195
hustimerstart	196
hustimerdelta	197
usstarttime	198
icapportadd	199

; lbp parser variables

lbprecvsize	220
lasty		221
startx		222
lbpcommand	223
lbpethaddr	224
lbpcaddr	226

fladdr		228	;double
fldata		230	;double
flcommflag	232
flspibyte	233

; user info - memspace 0 control = 1
mem0c		234	; hostmot2
lbpcookie0	234
lbptype_sizes0  235	;
lbpadd_ranges0	236	; 
lbpaddr0	237	;	
lbpspace0name0	238
lbpspace0name1	239
lbpspace0name2	240
lbpspace0name3	241
mem0cend	241

mem1c		242	; unused
lbpcookie1	242
lbptype_sizes1  243	;
lbpadd_ranges1	244	; 
lbpaddr1	245	;	
lbpspace1name0	246
lbpspace1name1	247
lbpspace1name2	248
lbpspace1name3	249
mem1cend	249

; LBP memspace 2 unused
mem2c		250
lbpcookie2	250
lbptype_sizes2  251	
lbpadd_ranges2	252	 
lbpaddr2	253
lbpspace2name0	254
lbpspace2name1	255
lbpspace2name2	256
lbpspace2name3	257

; LBP Flash EEPROM = memspace 3
mem3c		258
lbpcookie3	258
lbptype_sizes3  259	
lbpadd_ranges3	260	 
lbpaddr3	261
lbpspace3name0	262
lbpspace3name1	263
lbpspace3name2	264
lbpspace3name3	265

; Timer/utility = memspace 4 control = X
mem4c		266
lbpcookie4	266
lbptype_sizes4  267	
lbpadd_ranges4	268	 
lbpaddr4	269
lbpspace4name0	270
lbpspace4name1	271
lbpspace4name2	272
lbpspace4name3	273

; unused = memspace 5
mem5c		274
lbpcookie5	274
lbptype_sizes5  275	
lbpadd_ranges5	276	 
lbpaddr5	277
lbpspace5name0	278
lbpspace5name1	279
lbpspace5name2	280
lbpspace5name3	281

; LBP read/write region = memspace 6 control = X
mem6c		282
lbpcookie6	282
lbptype_sizes6  283	
lbpadd_ranges6	284	 
lbpaddr6	285
lbpspace6name0	286
lbpspace6name1	287
lbpspace6name2	288
lbpspace6name3	289

mem7c		290
lbpcookie7	290
lbptype_sizes7  291	;
lbpadd_ranges7	292	; 
lbpaddr7	293
lbpspace7name0	294
lbpspace7name1	295
lbpspace7name2	296
lbpspace7name3	297

mem4		298
timestamp	298	; reads return timeout, writes are no-op
uwait		299	; reads return last wait writes wait n usec
htimeout	300	; sets host timer timeout value in usec
rwait		301	; reads or writes wait till rising end of REF
hwait1		302	; reads or writes wait till rising edge of Timer1
hwait2		303	; "" timer2 
hwait3		304	; "" timer3
hwait4		305	; "" timer4	; reads of rwait or hwaits return usec waited


mem6		306
errorreg	306		;		
lbpparseerrors	307		
lbpmemerrors	308
lbpwriteerrors	309
recvpktcount	310	; 	
recvgoodcount	311	; 
recvbadcount	312	; 
sendpktcount	313 	; 
sendgoodcount	314	; 
sendbadcount	315	; 
ledmodeset	316
leddebugptr	317
pkttime		318
eepromwena	319
lbpreset	320
scratch		321	

mem6end		321

; LBP read only region = memspace 7 control = X


mem7		322
lbpcardname0    322	; Cardname character0,1 Read only 
lbpcardname1    323	; Cardname character2,3 Read only 
lbpcardname2    324	; Cardname character4,5 Read only 
lbpcardname3    325	; Cardname character6,7 Read only 
lbpcardname4    326	; Cardname character8,9 Read only 
lbpcardname5    327	; Cardname character10,11 Read only 
lbpcardname6    328	; Cardname character12,12 Read only 
lbpcardname7    329	; Cardname character14,13 Read only 
lbpversion      330     ; LBP Software Version, Read only 
firmwarever	331	; firmware version
optionjprs	332	; boot option jumpers
crcenable	333	; crc enable status
recvstart_ts	334
recvend_ts	335
sendstart_ts	336
sendend_ts	337
	



recvbuf		384	; 822 words = 1664 bytes
recvbufend	1205
sendbuf		1206	; 822 words = 1664 bytes
sendbufend	2047
endmem		2047
