init
	jsr	initmiscconsts
;	jsr	testflashunitnumber
;	jsr	eraselastblock
	jsr	initlbpconsts
	jsr	initlbpbuffers
	jsr	initrpcdatabase
	jsr	initdiscovery
	jsr	inituarts
	jsr	inithm2
	ret	

initmiscconsts
	ldib	0
	stab	zeroloc		
	ldib	1
	stab	oneloc		
	ldib	2
	stab	twoloc		
	ldib	0FFh
	stab	minusoneloc	
	ldib	0
	stab	rxpktcount
	ldib	0FFh
	stab	localledmode
	ldib	0
	stab	errorled
	ldib	lbplocalmem
	stab	lbplocalmemptr
	ldib	defaultwdtime
	stab	wdtimeout
	ret

initlbpconsts		; constant and variable initialization	
	ldib	0
	stab	lbpunitadd	
	stab	lbpstatus	
	ldib	0FFh
	stab	lbpcrcen	
	ldib	0
	stab	lbpcrcerrcnt	
	stab	lbpres_C4	
	stab	lbpres_C5	
	stab	lbpremswmode	
	stab	lbpclrremflt	
	stab	lbpres_C8	
	stab	lbpres_C9	
	ldib	0
	stab	lbpenarpcacc	
	ldib	20		; 20 bit times = 2 char times
	stab	lbpcommandto	
	ldib	0
	stab	lbpmemspace	
	stab	lbpres_CD	
	stab	lbpres_CE	
	stab	lbpres_CF	
	ldib	037h		; card name hardwired to 7IA0 currently
	stab	lbpcardname0	
	ldib	069h
	stab	lbpcardname1	
	ldib	061h
	stab	lbpcardname2	
	ldib	030h
	stab	lbpcardname3	
	ldib	5		;CRC and EEPROM
	stab	lbpcapability	
	ldib	2		; 
	stab	lbpremver	
	ldib	0
	stab	lbpremhwmode	
	stab	lbpleds		
	stab	lbpaddrlow	
	stab	lbpaddrhigh	
	stab	lbpaddrinc	
	ldib	1
	stab	lbpversion	
	ldib	0
	stab	lbpsetunitid	
	stab	lbprpcpitch	
	stab	lbprpcsizelow	
	stab	lbprpcsizehigh	
	ldib	05Ah		; cookie
	stab	lbpcookie	
	ldib	07Fh
	stab	txptrmask
;	jmp	versions 		; <<<<<<<<<<< TKLUDGE

readnvunit
	ldib	nvunitnumber&0FFh	; point T to nvunitnumber 
	stab	TL
	ldib	(nvunitnumber>>8)&0FFh
	stab	TH		; 	
	jsr 	finishfl	; force flash access mode to idle
	ldib	000h
	stab	fladdr+0
	ldib	000h
	stab	fladdr+1
	ldib	01Fh
	stab	fladdr+2	; serial number is in last erase sector of 16 Mbit chip
	jsr	readfl
	ldab	fldata+0
	stab	rpcunitnumber+0
	stab	@T,0
	ldab	fldata+1
	stab	rpcunitnumber+1
	stab	@T,1
	ldab	fldata+2
	stab	rpcunitnumber+2
	stab	@T,2
	ldab	fldata+3
	stab	rpcunitnumber+3
	stab	@T,3
	jsr	finishfl	; flash back to idle mode

versions
	ldib	swrevision&0FFh	; point T to swrevision 
	stab	TL
	ldib	(swrevision>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	010h	; remote swrevision
	stab	@T,0
	ldib	0
	stab	@T,1
	ldib	002h	; remote hwrevision
	stab	@T,2
	ldib	0
	stab	@T,3
	ret

initlbpbuffers
	jsr	initrxbuffer
	jsr	inittxbuffer
	ret

initrxbuffer
	ldib	rxbuffer&0FFh	; point X to rx buffer 
	stab	XL
	ldib	(rxbuffer>>8)&0FFh
	stab	XH		; 	
	ret
inittxbuffer
	ldib	txbuffer&0FFh	; point Y to tx buffer 
	stab	YL
	ldib	(txbuffer>>8)&0FFh
	stab	YH		; 	
	ret

inituarts
	ldab	defaulthsbrl
	stab	pktrxratel
	stab	pkttxratel
	ldab	defaulthsbrm
	stab	pktrxratem
	stab	pkttxratem
	ldab	defaulthsbrh
	stab	pktrxrateh
	stab	pkttxrateh
	ldib	000h
	stab	pkttxframeto	; no interframe delay on xmit
	ldib	001h
	stab	pktrxstatus	; clear rx uart
	stab	pkttxstatus	; clear tx uart
	ldib	040h		; set txen bit		
	stab	pkttxmode
	ldib	008h		; set rxen bit		
	stab	pktrxmode
initrxto
	ldab	lbpcommandto	
	stab	pktrxframeto	
	ret


initrpcdatabase

	ldib	hwmode0&0FFh	; store address of hwmode 0 GTOC entry 0
	stab	m0gtoc0+0	; 
	ldib	(hwmode0>>8)&0FFH
	stab	m0gtoc0+1

	ldib	swmode0&0FFh	; store address of swmode 0 GTOC entry 1
	stab	m0gtoc0+2	; 
	ldib	(swmode0>>8)&0FFH
	stab	m0gtoc0+3

	ldib	m0gdd0&0FFh	; store address of GDD0 0 to GTOC entry 2
	stab	m0gtoc0+4	; 
	ldib	(m0gdd0>>8)&0FFH
	stab	m0gtoc0+5

	ldib	m0gdd1&0FFh	; store address of GDD0 1 to GTOC entry 3
	stab	m0gtoc0+6	; 
	ldib	(m0gdd1>>8)&0FFH
	stab	m0gtoc0+7

	ldib	m0gdd2&0FFh	; store address of GDD0 2 to GTOC entry 4
	stab	m0gtoc0+8	; 
	ldib	(m0gdd2>>8)&0FFH
	stab	m0gtoc0+9

	ldib	m0gdd3&0FFh	; store address of GDD0 3 to GTOC entry 5
	stab	m0gtoc0+10	; 
	ldib	(m0gdd3>>8)&0FFH
	stab	m0gtoc0+11

	ldib	m0gdd4&0FFh	; store address of GDD0 4 to GTOC entry 6
	stab	m0gtoc0+12	; 
	ldib	(m0gdd4>>8)&0FFH
	stab	m0gtoc0+13

	ldib	m0gdd5&0FFh	; store address of GDD0 5 to GTOC entry 7
	stab	m0gtoc0+14	; 
	ldib	(m0gdd5>>8)&0FFH
	stab	m0gtoc0+15

	ldib	m0gdd6&0FFh	; store address of GDD0 6 to GTOC entry 8
	stab	m0gtoc0+16	; 
	ldib	(m0gdd6>>8)&0FFH
	stab	m0gtoc0+17

	ldib	m0gdd7&0FFh	; store address of GDD0 7 to GTOC entry 9
	stab	m0gtoc0+18	; 
	ldib	(m0gdd7>>8)&0FFH
	stab	m0gtoc0+19

	ldib	m0gdd8&0FFh	; store address of GDD0 8 to GTOC entry 10
	stab	m0gtoc0+20	; 
	ldib	(m0gdd8>>8)&0FFH
	stab	m0gtoc0+21

	ldib	m0gdd9&0FFh	; store address of GDD0 9 to GTOC entry 11
	stab	m0gtoc0+22	; 
	ldib	(m0gdd9>>8)&0FFH
	stab	m0gtoc0+23

	ldib	m0gdd10&0FFh	; store address of GDD0 10 to GTOC entry 12
	stab	m0gtoc0+24	; 
	ldib	(m0gdd10>>8)&0FFH
	stab	m0gtoc0+25

	ldib	m0gdd11&0FFh	; store address of GDD0 11 to GTOC entry 13
	stab	m0gtoc0+26	; 
	ldib	(m0gdd11>>8)&0FFH
	stab	m0gtoc0+27

	ldib	m0gdd12&0FFh	; store address of GDD0 12 to GTOC entry 14
	stab	m0gtoc0+28	; 
	ldib	(m0gdd12>>8)&0FFH
	stab	m0gtoc0+29

	ldib	m0gdd13&0FFh	; store address of GDD0 13 to GTOC entry 15
	stab	m0gtoc0+30	; 
	ldib	(m0gdd13>>8)&0FFH
	stab	m0gtoc0+31

	ldib	m0gdd14&0FFh	; store address of GDD0 14 to GTOC entry 16
	stab	m0gtoc0+32	; 
	ldib	(m0gdd14>>8)&0FFH
	stab	m0gtoc0+33

	ldib	0	
	stab	m0gtoc0+34	; last GTOC entry is zero
	stab	m0gtoc0+35

; these could be more compactly coded...
mode0gddrec0
	ldib	m0gdd0&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd0>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc0mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc0mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'0'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec1
	ldib	m0gdd1&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd1>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc1mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc1mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'1'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec2
	ldib	m0gdd2&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd2>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc2mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc2mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'2'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec3
	ldib	m0gdd3&0FFh	; point T to m0gdd3 
	stab	TL
	ldib	(m0gdd3>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc3mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc3mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'3'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec4
	ldib	m0gdd4&0FFh	; point T to m0gdd4 
	stab	TL
	ldib	(m0gdd4>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	swrevision&0FFh	;transfer data address
	stab	@T,12
	ldib	(swrevision>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	'w'
	stab	@T,19
	ldib	'r'
	stab	@T,20
	ldib	'e'
	stab	@T,21
	ldib	'v'
	stab	@T,22
	ldib	'i'
	stab	@T,23
	ldib	's'
	stab	@T,24
	ldib	'i'
	stab	@T,25
	ldib	'o'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	0		; terminate
	stab	@T,28
	ldib	0
	stab	@T,29

mode0gddrec5
	ldib	m0gdd5&0FFh	; point T to m0gdd5 
	stab	TL
	ldib	(m0gdd5>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	hwrevision&0FFh	;transfer data address
	stab	@T,12
	ldib	(hwrevision>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'h'
	stab	@T,18
	ldib	'w'
	stab	@T,19
	ldib	'r'
	stab	@T,20
	ldib	'e'
	stab	@T,21
	ldib	'v'
	stab	@T,22
	ldib	'i'
	stab	@T,23
	ldib	's'
	stab	@T,24
	ldib	'i'
	stab	@T,25
	ldib	'o'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	0		; terminate
	stab	@T,28
	ldib	0
	stab	@T,29

mode0gddrec6
	ldib	m0gdd6&0FFh	; point T to m0gdd6 
	stab	TL
	ldib	(m0gdd6>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	32		; 32 bits
	stab	@T,1
	ldib	ddnvunsignedtype	; type 4 = nvunsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	nvunitnumber&0FFh	;transfer data address
	stab	@T,12
	ldib	(nvunitnumber>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'n'
	stab	@T,18
	ldib	'v'
	stab	@T,19
	ldib	'u'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'i'
	stab	@T,22
	ldib	't'
	stab	@T,23
	ldib	'n'
	stab	@T,24
	ldib	'u'
	stab	@T,25
	ldib	'm'
	stab	@T,26
	ldib	'b'
	stab	@T,27
	ldib	'e'
	stab	@T,28
	ldib	'r'
	stab	@T,29
	ldib	0		; terminate
	stab	@T,30
	ldib	0
	stab	@T,31

mode0gddrec7
	ldib	m0gdd7&0FFh	; point T to m0gdd7 
	stab	TL
	ldib	(m0gdd7>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux0scandiv&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux0scandiv>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'0'
	stab	@T,19
	ldib	'0'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'2'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'a'
	stab	@T,26
	ldib	'm'
	stab	@T,27
	ldib	'p'
	stab	@T,28
	ldib	'l'
	stab	@T,29
	ldib	'e'
	stab	@T,30
	ldib	'-'
	stab	@T,31
	ldib	't'
	stab	@T,32
	ldib	'i'
	stab	@T,33
	ldib	'm'
	stab	@T,34
	ldib	'e'
	stab	@T,35
	ldib	0
	stab	@T,36

mode0gddrec8
	ldib	m0gdd8&0FFh	; point T to m0gdd8 
	stab	TL
	ldib	(m0gdd8>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux1scandiv&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux1scandiv>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'2'
	stab	@T,19
	ldib	'4'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'4'
	stab	@T,22
	ldib	'7'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'a'
	stab	@T,26
	ldib	'm'
	stab	@T,27
	ldib	'p'
	stab	@T,28
	ldib	'l'
	stab	@T,29
	ldib	'e'
	stab	@T,30
	ldib	'-'
	stab	@T,31
	ldib	't'
	stab	@T,32
	ldib	'i'
	stab	@T,33
	ldib	'm'
	stab	@T,34
	ldib	'e'
	stab	@T,35
	ldib	0
	stab	@T,36

mode0gddrec9
	ldib	m0gdd9&0FFh	; point T to m0gdd9 
	stab	TL
	ldib	(m0gdd9>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux0fscans&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux0fscans>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'0'
	stab	@T,19
	ldib	'0'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'2'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	'f'
	stab	@T,25
	ldib	'a'
	stab	@T,26
	ldib	's'
	stab	@T,27
	ldib	't'
	stab	@T,28
	ldib	'-'
	stab	@T,29
	ldib	'f'
	stab	@T,30
	ldib	'i'
	stab	@T,31
	ldib	'l'
	stab	@T,32
	ldib	't'
	stab	@T,33
	ldib	0
	stab	@T,34

mode0gddrec10
	ldib	m0gdd10&0FFh	; point T to m0gdd10 
	stab	TL
	ldib	(m0gdd10>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux1fscans&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux1fscans>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'2'
	stab	@T,19
	ldib	'4'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'4'
	stab	@T,22
	ldib	'7'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	'f'
	stab	@T,25
	ldib	'a'
	stab	@T,26
	ldib	's'
	stab	@T,27
	ldib	't'
	stab	@T,28
	ldib	'-'
	stab	@T,29
	ldib	'f'
	stab	@T,30
	ldib	'i'
	stab	@T,31
	ldib	'l'
	stab	@T,32
	ldib	't'
	stab	@T,33
	ldib	0
	stab	@T,34

mode0gddrec11
	ldib	m0gdd11&0FFh	; point T to m0gdd11
	stab	TL
	ldib	(m0gdd11>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux0sscans&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux0sscans>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'0'
	stab	@T,19
	ldib	'0'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'2'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'l'
	stab	@T,26
	ldib	'o'
	stab	@T,27
	ldib	'w'
	stab	@T,28
	ldib	'-'
	stab	@T,29
	ldib	'f'
	stab	@T,30
	ldib	'i'
	stab	@T,31
	ldib	'l'
	stab	@T,32
	ldib	't'
	stab	@T,33
	ldib	0
	stab	@T,34

mode0gddrec12
	ldib	m0gdd12&0FFh	; point T to m0gdd12
	stab	TL
	ldib	(m0gdd12>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux1sscans&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux1sscans>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'2'
	stab	@T,19
	ldib	'4'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'4'
	stab	@T,22
	ldib	'7'
	stab	@T,23
	ldib	'-'
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'l'
	stab	@T,26
	ldib	'o'
	stab	@T,27
	ldib	'w'
	stab	@T,28
	ldib	'-'
	stab	@T,29
	ldib	'f'
	stab	@T,30
	ldib	'i'
	stab	@T,31
	ldib	'l'
	stab	@T,32
	ldib	't'
	stab	@T,33
	ldib	0

mode0gddrec13
	ldib	m0gdd13&0FFh	; point T to m0gdd13
	stab	TL
	ldib	(m0gdd13>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	32		; 32 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = bits
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux0slowmask&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux0slowmask>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'0'
	stab	@T,19
	ldib	'0'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'2'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	'-'	
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'l'	
	stab	@T,26
	ldib	'o'	
	stab	@T,27
	ldib	'w'	
	stab	@T,28
	ldib	'-'	
	stab	@T,29
	ldib	'm'	
	stab	@T,30
	ldib	'a'	
	stab	@T,31
	ldib	's'	
	stab	@T,32
	ldib	'k'	
	stab	@T,33
	ldib	0	
	stab	@T,34

mode0gddrec14
	ldib	m0gdd14&0FFh	; point T to m0gdd14
	stab	TL
	ldib	(m0gdd14>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	24		; 24 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inmux1slowmask&0FFh	;transfer data address
	stab	@T,12
	ldib	(inmux1slowmask>>8)&0FFH
	stab	@T,13
	ldib	'u'
	stab	@T,14
	ldib	0
	stab	@T,15
	ldib	'i'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	'-'
	stab	@T,18
	ldib	'2'
	stab	@T,19
	ldib	'4'
	stab	@T,20
	ldib	'-'
	stab	@T,21
	ldib	'4'
	stab	@T,22
	ldib	'7'
	stab	@T,23
	ldib	'-'	
	stab	@T,24
	ldib	's'
	stab	@T,25
	ldib	'l'	
	stab	@T,26
	ldib	'o'	
	stab	@T,27
	ldib	'w'	
	stab	@T,28
	ldib	'-'	
	stab	@T,29
	ldib	'm'	
	stab	@T,30
	ldib	'a'	
	stab	@T,31
	ldib	's'	
	stab	@T,32
	ldib	'k'	
	stab	@T,33
	ldib	0	

	ldib	hwmode0&0FFh	; store address of hwmode 0 PTOC entry 0
	stab	m0ptoc0+0	; 
	ldib	(hwmode0>>8)&0FFH
	stab	m0ptoc0+1

	ldib	swmode0&0FFh	; store address of swmode 0 PTOC entry 1
	stab	m0ptoc0+2	; 
	ldib	(swmode0>>8)&0FFH
	stab	m0ptoc0+3

	ldib	m0pdd0&0FFh	; store address of PDD0 in PTOC entry 2 
	stab	m0ptoc0+4	; (PDD 0 is mode 0 input bits 0..47)    
	ldib	(m0pdd0>>8)&0FFH                                        
	stab	m0ptoc0+5                                               

#IFDEF EIGHTBITMPGS
	ldib	m0pdd1&0FFh	; store address of PDD1 in PTOC entry 3 
	stab	m0ptoc0+6	; (PDD 1 is mode 0 8 bit mpg counts 0)  
	ldib	(m0pdd1>>8)&0FFH                                        
	stab	m0ptoc0+7                                               

	ldib	m0pdd2&0FFh	; store address of PDD2 in PTOC entry 4 
	stab	m0ptoc0+8	; (PDD 2 is mode 0 8 bit mpg counts 1)  
	ldib	(m0pdd2>>8)&0FFH                                        
	stab	m0ptoc0+9                                               

	ldib	m0pdd3&0FFh	; store address of PDD3 in PTOC entry 5 
	stab	m0ptoc0+10	; (PDD 3 is mode 0 8 bit mpg counts 2)  
	ldib	(m0pdd3>>8)&0FFH                                        
	stab	m0ptoc0+11                                              

	ldib	m0pdd4&0FFh	; store address of PDD4 in PTOC entry 6 
	stab	m0ptoc0+12	; (PDD 4 is mode 0 8 bit mpg counts 3)  
	ldib	(m0pdd4>>8)&0FFH                                        
	stab	m0ptoc0+13                                              
#ENDIF

#IFDEF FOURBITMPGS
	ldib	m0pdd10&0FFh	; store address of PDD10 in PTOC entry 3 
	stab	m0ptoc0+6	; (PDD 10 is mode 0 4 bit mpg counts 0)  
	ldib	(m0pdd10>>8)&0FFH                                        
	stab	m0ptoc0+7                                               

	ldib	m0pdd11&0FFh	; store address of PDD11 in PTOC entry 4 
	stab	m0ptoc0+8	; (PDD 11 is mode 0 4 bit mpg counts 1)  
	ldib	(m0pdd11>>8)&0FFH                                        
	stab	m0ptoc0+9                                               

	ldib	m0pdd12&0FFh	; store address of PDD12 in PTOC entry 5 
	stab	m0ptoc0+10	; (PDD 12 is mode 0 4 bit mpg counts 2)  
	ldib	(m0pdd12>>8)&0FFH                                        
	stab	m0ptoc0+11                                              

	ldib	m0pdd13&0FFh	; store address of PDD13 in PTOC entry 6 
	stab	m0ptoc0+12	; (PDD 12 is mode 0 4 bit mpg counts 3)  
	ldib	(m0pdd13>>8)&0FFH                                        
	stab	m0ptoc0+13                                              
#ENDIF
	ldib	m0pdd6&0FFh	; store address of PDD6 in PTOC entry 7 
	stab	m0ptoc0+14	; (PDD 6 is mode 0 8 bit analog in 0)   
	ldib	(m0pdd6>>8)&0FFH                                        
	stab	m0ptoc0+15                                              

	ldib	m0pdd7&0FFh	; store address of PDD7 in PTOC entry 8 
	stab	m0ptoc0+16	; (PDD 7 is mode 0 8 bit analog in 1))  
	ldib	(m0pdd7>>8)&0FFH                                        
	stab	m0ptoc0+17                                              

#IFDEF EIGHTBITMPGS
	ldib	m0pdd5&0FFh	; store address of PDD5 in PTOC entry 9 
	stab	m0ptoc0+18	; (PDD 5 is mode 0 24 bit xfrmr out))   
	ldib	(m0pdd5>>8)&0FFH
	stab	m0ptoc0+19

	ldib	0	
	stab	m0ptoc0+20	; last PTOC entry is zero               
	stab	m0ptoc0+21
#ENDIF

#IFDEF FOURBITMPGS 
	ldib	m0pdd8&0FFh	; store address of PDD8 in PTOC entry 10 
	stab	m0ptoc0+18	; (PDD 8 is mode 0 8 bit analog in 2)   
	ldib	(m0pdd8>>8)&0FFH                                        
	stab	m0ptoc0+19                                              

	ldib	m0pdd9&0FFh	; store address of PDD9 in PTOC entry 11 
	stab	m0ptoc0+20	; (PDD 9 is mode 0 8 bit analog in 3))  
	ldib	(m0pdd9>>8)&0FFH                                        
	stab	m0ptoc0+21                                              

	ldib	m0pdd5&0FFh	; store address of PDD5 in PTOC entry 12 
	stab	m0ptoc0+22	; (PDD 5 is mode 0 24 bit xfrmr out))   
	ldib	(m0pdd5>>8)&0FFH
	stab	m0ptoc0+23

	ldib	0	
	stab	m0ptoc0+24	; last PTOC entry is zero               
	stab	m0ptoc0+25
#ENDIF

mode0hwmoderec0
	ldib	0B0h		; mode record type
	stab	hwmode0+0
	ldib	0		; mode index
	stab	hwmode0+1
	ldib	0		; mode type = hw
	stab	hwmode0+2
	ldib	0
	stab	hwmode0+3	; unused
	ldib	's'		; mode name string
	stab	hwmode0+4	
	ldib	't'		
	stab	hwmode0+5	
	ldib	'a'		
	stab	hwmode0+6	
	ldib	'n'		
	stab	hwmode0+7	
	ldib	'd'		
	stab	hwmode0+8	
	ldib	'a'		
	stab	hwmode0+9	
	ldib	'r'		
	stab	hwmode0+10	
	ldib	'd'		
	stab	hwmode0+11	
	ldib	0		;terminator		
	stab	hwmode0+12	

mode0swmoderec0
	ldib	0B0h		; mode record type
	stab	swmode0+0
	ldib	0		; mode index
	stab	swmode0+1
	ldib	1		; mode type = sw
	stab	swmode0+2
	ldib	0
	stab	swmode0+3	; unused
	ldib	's'		; mode name string
	stab	swmode0+4	
	ldib	't'		
	stab	swmode0+5	
	ldib	'a'		
	stab	swmode0+6	
	ldib	'n'		
	stab	swmode0+7	
	ldib	'd'		
	stab	swmode0+8	
	ldib	'a'		
	stab	swmode0+9	
	ldib	'r'		
	stab	swmode0+10	
	ldib	'd'		
	stab	swmode0+11	
	ldib	0		; terminator
	stab	swmode0+12	

mode0pddrec0
	ldib	m0pdd0&0FFh	; point T to m0pdd0 
	stab	TL
	ldib	(m0pdd0>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	48		; 48 bits
	stab	@T,1
	ldib	ddbittype	; type 1 = bits
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	inputbits&0FFh	;transfer data address
	stab	@T,12
	ldib	(inputbits>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'I'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	0
	stab	@T,20

; 8 bit MPG encoders PDD 1..4
mode0pddrec1_8bitmpg
	ldib	m0pdd1&0FFh	; point T to m0pdd1 
	stab	TL
	ldib	(m0pdd1>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder0&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder0>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'e'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'0'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec2_8bitmpg
	ldib	m0pdd2&0FFh	; point T to m0pdd2 
	stab	TL
	ldib	(m0pdd2>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder1&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder1>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'1'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec3_8bitmpg
	ldib	m0pdd3&0FFh	; point T to m0pdd3 
	stab	TL
	ldib	(m0pdd3>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder2&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder2>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'2'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec4_8bitmpg
	ldib	m0pdd4&0FFh	; point T to m0pdd4 
	stab	TL
	ldib	(m0pdd4>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder3&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder3>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	0
	stab	@T,24
;24 outs
mode0pddrec5
	ldib	m0pdd5&0FFh	; point T to m0pdd5 
	stab	TL
	ldib	(m0pdd5>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	24		; 24 bits
	stab	@T,1
	ldib	ddbittype	; type 1 = bits
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	xfrmrout&0FFh	;transfer data address
	stab	@T,12
	ldib	(xfrmrout>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'O'
	stab	@T,18
	ldib	'u'
	stab	@T,19
	ldib	't'
	stab	@T,20
	ldib	0
	stab	@T,21

;analog inputs PDD 6..9
mode0pddrec6
	ldib	m0pdd6&0FFh	; point T to m0pdd6 
	stab	TL
	ldib	(m0pdd6>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = 0
	stab	@T,5
	stab	@T,6
	stab	@T,7
	ldib	033h
	stab	@T,8	; param_max = 3.3
	ldib	033h
	stab	@T,9
	ldib	053h
	stab	@T,10
	ldib	040h
	stab	@T,11
	ldib	analog0&0FFh	;transfer data address
	stab	@T,12
	ldib	(analog0>>8)&0FFH
	stab	@T,13
	ldib	'v'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'l'
	stab	@T,16
	ldib	't'
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'A'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'a'
	stab	@T,22
	ldib	'l'
	stab	@T,23
	ldib	'o'
	stab	@T,24
	ldib	'g'
	stab	@T,25
	ldib	'I'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	'0'
	stab	@T,28
	ldib	0
	stab	@T,29

mode0pddrec7
	ldib	m0pdd7&0FFh	; point T to m0pdd7 
	stab	TL
	ldib	(m0pdd7>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = 0
	stab	@T,5
	stab	@T,6
	stab	@T,7
	ldib	033h
	stab	@T,8	; param_max = 3.3
	ldib	033h
	stab	@T,9
	ldib	053h
	stab	@T,10
	ldib	040h
	stab	@T,11
	ldib	analog1&0FFh	;transfer data address
	stab	@T,12
	ldib	(analog1>>8)&0FFH
	stab	@T,13
	ldib	'v'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'l'
	stab	@T,16
	ldib	't'
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'A'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'a'
	stab	@T,22
	ldib	'l'
	stab	@T,23
	ldib	'o'
	stab	@T,24
	ldib	'g'
	stab	@T,25
	ldib	'I'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	'1'
	stab	@T,28
	ldib	0
	stab	@T,29

mode0pddrec8
	ldib	m0pdd8&0FFh	; point T to m0pdd8 
	stab	TL
	ldib	(m0pdd8>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = 0
	stab	@T,5
	stab	@T,6
	stab	@T,7
	ldib	033h
	stab	@T,8	; param_max = 3.3
	ldib	033h
	stab	@T,9
	ldib	053h
	stab	@T,10
	ldib	040h
	stab	@T,11
	ldib	analog2&0FFh	;transfer data address
	stab	@T,12
	ldib	(analog2>>8)&0FFH
	stab	@T,13
	ldib	'v'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'l'
	stab	@T,16
	ldib	't'
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'A'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'a'
	stab	@T,22
	ldib	'l'
	stab	@T,23
	ldib	'o'
	stab	@T,24
	ldib	'g'
	stab	@T,25
	ldib	'I'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	'2'
	stab	@T,28
	ldib	0
	stab	@T,29

mode0pddrec9
	ldib	m0pdd9&0FFh	; point T to m0pdd9 
	stab	TL
	ldib	(m0pdd9>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = 0
	stab	@T,5
	stab	@T,6
	stab	@T,7
	ldib	033h
	stab	@T,8	; param_max = 3.3
	ldib	033h
	stab	@T,9
	ldib	053h
	stab	@T,10
	ldib	040h
	stab	@T,11
	ldib	analog3&0FFh	;transfer data address
	stab	@T,12
	ldib	(analog3>>8)&0FFH
	stab	@T,13
	ldib	'v'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'l'
	stab	@T,16
	ldib	't'
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'A'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'a'
	stab	@T,22
	ldib	'l'
	stab	@T,23
	ldib	'o'
	stab	@T,24
	ldib	'g'
	stab	@T,25
	ldib	'I'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	'3'
	stab	@T,28
	ldib	0
	stab	@T,29

; 4 bit MPG encoders PDD10..13
mode0pddrec1_4bitmpg
	ldib	m0pdd10&0FFh	; point T to m0pdd10 
	stab	TL
	ldib	(m0pdd10>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	4		; 4 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder0&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder0>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'e'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'0'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec2_4bitmpg
	ldib	m0pdd11&0FFh	; point T to m0pdd11 
	stab	TL
	ldib	(m0pdd11>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	4		; 4 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder1&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder1>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'1'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec3_4bitmpg
	ldib	m0pdd12&0FFh	; point T to m0pdd12 
	stab	TL
	ldib	(m0pdd12>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	4		; 4 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder2&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder2>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'2'
	stab	@T,23
	ldib	0
	stab	@T,24

mode0pddrec4_4bitmpg
	ldib	m0pdd13&0FFh	; point T to m0pdd13 
	stab	TL
	ldib	(m0pdd13>>8)&0FFh
	stab	TH
	nop
	nop
	ldib	0A0h
	stab	@T,0	; process data descriptor record
	ldib	4		; 4 bits
	stab	@T,1
	ldib	ddcounttype	; type 8 = count
	stab	@T,2
	ldib	dddirectionin	; input
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	encoder3&0FFh	;transfer data address
	stab	@T,12
	ldib	(encoder3>>8)&0FFH
	stab	@T,13
	ldib	'c'
	stab	@T,14
	ldib	'o'
	stab	@T,15
	ldib	'u'
	stab	@T,16
	ldib	'n'
	stab	@T,17
	ldib	't'
	stab	@T,18
	ldib	0
	stab	@T,19
	ldib	'E'
	stab	@T,20
	ldib	'n'
	stab	@T,21
	ldib	'c'
	stab	@T,22
	ldib	'3'
	stab	@T,23
	ldib	0
	stab	@T,24

	ret
	
initdiscovery
	ldib	0
	subb	lbpremswmode
	jmpz	mode0init
	ldib	1
	subb	lbpremswmode
	jmpz	mode1init
	
mode0init
	ldib	m0ptoc0&0FFh	; process TOC 
	stab	rpcptoc+0
	ldib	(m0ptoc0>>8)&0FFH	
	stab	rpcptoc+1
	ldib	m0gtoc0&0FFh	; global TOC 
	stab	rpcgtoc+0
	ldib	(m0gtoc0>>8)&0FFH
	stab	rpcgtoc+1
	ldib	13
	stab	rpctxsize
	ldib	3
	stab	rpcrxsize
	ret
mode1init
	ret

inithm2
	jsr	fixddrs
	jsr	initxfrmrs
	jsr	initinmuxs
	jsr	updateinmuxcr
	jsr	initdsad
	ret

initxfrmrs
	ldib	0		; clear SSR data register
	stab	hm2data0
	stab	hm2data1
	stab	hm2data2
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	07Dh
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	060h		; setup SSR rate/enable register
	stab	hm2data0
	ldib	010h		; enable + 500 KHz
	stab	hm2data1
	ldib	000h	
	stab	hm2data2
	ldib	000h	
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	07Eh
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret

initinmuxs			
				; default filter timings	
	ldib	52		; divide by 52*24 = 50 usec period
	stab	inmux0scandiv+0
	ldib	0
	stab	inmux0scandiv+1

	ldib	52		; divide by 52+24 = 50 usec period
	stab	inmux1scandiv+0
	ldib	0
	stab	inmux1scandiv+1

	ldib	4		; 4 fast scans = ~200 usec
	stab	inmux0fscans+0

	ldib	4		; 4 fast scans = ~200 usec
	stab	inmux1fscans+0

	ldib	40		; 40 slow scans = ~2 ms
	stab	inmux0sscans+0
	ldib	0
	stab	inmux0sscans+1

	ldib	40		; 40 slow scans = ~2 ms
	stab	inmux1sscans+0
	ldib	0
	stab	inmux1sscans+1

	ldib	0		; fast on low 8 of inmux0
	stab	inmux0slowmask+0	; for MPG use
	ldib	0FFh
	stab	inmux0slowmask+1	; slow everywhere else
	stab	inmux0slowmask+2
	stab	inmux1slowmask+0
	stab	inmux1slowmask+1
	stab	inmux1slowmask+2
	ret 

updateinmuxcr
	ldib	020h		; global inv
	stab	inmux0crimage+0
	ldib	MinusOne	; rate is 25 MHz/div+1 so compensate	
	addb	inmux0scandiv+0	; by subtracting one
	stab	templ+0
	ldib	MinusOne
	addcb	inmux0scandiv+1
	stab	templ+1
	ldab	templ+0
	jsr	shiftl6
	ortob	inmux0crimage+0	; or in global inv
	ldab	templ+0
	jsr	shiftr2
	stab	templ+0
	ldib	003h
	andb	templ+1		; from decremented MSByte of scandiv
	jsr	shiftl6
	orb	templ+0
	stab	inmux0crimage+1	;	
	ldib	03Fh		; 
	andb	inmux0fscans
	stab	templ+2
	ldab	inmux0sscans+0
	jsr	shiftl6
	orb	templ+2		
	stab	inmux0crimage+2	
	ldab	inmux0sscans+0
	jsr	shiftr2
	stab	templ+3
	ldab	inmux0sscans+1
	jsr	shiftl6
	orb	templ+3
	stab	inmux0crimage+3
	ldab	inmux0crimage+0
	stab	hm2data0
	ldab	inmux0crimage+1
	stab	hm2data1	;
	ldab	inmux0crimage+2
	stab	hm2data2
	ldab	inmux0crimage+3
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	080h		; inmux 0 control reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldab	inmux0slowmask+0	; setup filter register
	stab	hm2data0
	ldab	inmux0slowmask+1
	stab	hm2data1
	ldab	inmux0slowmask+2
	stab	hm2data2
	ldib	000h	
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	081h		; inmux 0 filter reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
				; second inmux
	ldib	020h		; global inv
	stab	inmux1crimage+0
	ldib	MinusOne	; rate is 25 MHz/div+1 so compensate	
	addb	inmux1scandiv+0	; by subtracting one
	stab	templ+0
	ldib	MinusOne
	addcb	inmux1scandiv+1
	stab	templ+1
	ldab	templ+0
	jsr	shiftl6
	ortob	inmux1crimage+0	; or in global inv
	ldab	templ+0
	jsr	shiftr2
	stab	templ+0
	ldib	003h
	andb	templ+1		; from decremented MSByte of scandiv
	jsr	shiftl6
	orb	templ+0
	stab	inmux1crimage+1	;	
	ldib	03Fh		; 
	andb	inmux1fscans
	stab	templ+2
	ldab	inmux1sscans+0
	jsr	shiftl6
	orb	templ+2		
	stab	inmux1crimage+2	
	ldab	inmux1sscans+0
	jsr	shiftr2
	stab	templ+3
	ldab	inmux1sscans+1
	jsr	shiftl6
	orb	templ+3
	stab	inmux1crimage+3
	ldab	inmux1crimage+0
	stab	hm2data0
	ldab	inmux1crimage+1
	stab	hm2data1	;
	ldab	inmux1crimage+2
	stab	hm2data2
	ldab	inmux1crimage+3
	stab	hm2data3
	ldib	004h
	stab	hm2addr0
	ldib	080h		; inmux 1 control reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldab	inmux1slowmask+0		; setup filter register
	stab	hm2data0
	ldab	inmux1slowmask+1
	stab	hm2data1
	ldab	inmux1slowmask+2
	stab	hm2data2
	ldib	000h	
	stab	hm2data3
	ldib	004h
	stab	hm2addr0
	ldib	081h		; inmux 1 filter reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret

initdsad
	ldib	00Fh		; bit 15 MSB so 16 bits
	stab	hm2data0
	ldib	080h		; 50% zero PWM setting
	stab	hm2data1	;
	ldib	000h	
	stab	hm2data2
	ldib	000h		; 
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	090h		; dsad control reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret

initparams
	ldib	enc0mode&0FFh	; point T to enc0mode 
	stab	TL
	ldib	(enc0mode>>8)&0FFh
	stab	TH		; 	
	ldib	0
	nop
	nop
	stab	@T,0
	stab	@T,1
	stab	@T,2
	stab	@T,3
	ret

testflashunitnumber
	jsr	finishfl	; finish any ops in progress
	ldib	000h
	stab	fladdr+0
	stab	fladdr+1
	ldib	01Fh
	stab	fladdr+2	; serial number is in last erase sector of 16 Mbit chip
	ldib	000h
	stab	fldata+0	
	stab	fldata+1
	stab	fldata+2
	ldib	01Bh
	stab	fldata+3
	jsr	writefl	
	jsr	finishfl
	ret

eraselastblock
	jsr	finishfl	; finish any ops in progress
	ldib	000h
	stab	fladdr+0
	stab	fladdr+1
	ldib	01Fh
	stab	fladdr+2	; serial number is in last erase sector of 16 Mbit chip
	jsr	erasefl
	jsr	finishfl
	ret

shiftl6
	addb	zeroloc		; clear carry
	rclb			; shl 6 to get LS 2 bits in MSBs
	addb	zeroloc		; clear carry
	rclb
	addb	zeroloc		; clear carry
	rclb
	addb	zeroloc		; clear carry
	rclb
	addb	zeroloc		; clear carry
	rclb
	addb	zeroloc		; clear carry
	rclb
	ret

shiftr2
	addb	zeroloc		; shift right 2 which is awkward with rotate			
	rcrb			; rot right  
	addb	zeroloc		; clear carry
	rcrb
	ret
