init
	jsr	initmiscconsts
	jsr	initlbpconsts
	jsr	initlbpbuffers
	jsr	initrpcdatabase
	jsr	initdiscovery
	jsr	inituarts
	jsr	inithm2

	ret	

initmiscconsts
	ldib	0
	stab	zeroloc		
	ldib	1
	stab	oneloc		
	ldib	2
	stab	twoloc		
	ldib	0FFh
	stab	minusoneloc	
	ldib	0
	stab	rxpktcount
	ldib	0FFh
	stab	localledmode
	ldib	0
	stab	errorled
	ldib	lbplocalmem
	stab	lbplocalmemptr
	ldib	defaultwdtime
	stab	wdtimeout
	ret

initlbpconsts		; constant and variable initialization	
	ldib	0
	stab	lbpunitadd	
	stab	lbpstatus	
	ldib	0FFh
	stab	lbpcrcen	
	ldib	0
	stab	lbpcrcerrcnt	
	stab	lbpres_C4	
	stab	lbpres_C5	
	stab	lbpremswmode	
	stab	lbpclrremflt	
	stab	lbpres_C8	
	stab	lbpres_C9	
	ldib	0
	stab	lbpenarpcacc	
	ldib	20		; 20 bit times = 2 char times
	stab	lbpcommandto	
	ldib	0
	stab	lbpmemspace	
	stab	lbpres_CD	
	stab	lbpres_CE	
	stab	lbpres_CF	
	ldib	037h		; card name hardwired to 7I90 currently
	stab	lbpcardname0	
	ldib	069h
	stab	lbpcardname1	
	ldib	039h
	stab	lbpcardname2	
	ldib	030h
	stab	lbpcardname3	
	ldib	1		;CRC capable only
	stab	lbpcapability	
	ldib	14		; so driver doesnt bitch about old revs
	stab	lbpremver	
	ldib	0
	stab	lbpremhwmode	
	stab	lbpleds		
	stab	lbpaddrlow	
	stab	lbpaddrhigh	
	stab	lbpaddrinc	
	ldib	1
	stab	lbpversion	
	ldib	0
	stab	lbpsetunitid	
	stab	lbprpcpitch	
	stab	lbprpcsizelow	
	stab	lbprpcsizehigh	
	ldib	05Ah		; cookie
	stab	lbpcookie	
	ldib	07Fh
	stab	txptrmask
	ldib	078h
	stab	rpcunitnumber+0
	ldib	056h
	stab	rpcunitnumber+1
	ldib	034h
	stab	rpcunitnumber+2
	ldib	012h
	stab	rpcunitnumber+3
versions
	ldib	swrevision&0FFh	; point T to swrevision 
	stab	TL
	ldib	(swrevision>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	00Fh
	stab	@T,0
	ldib	0
	stab	@T,1
	ldib	001h
	stab	@T,2
	ldib	0
	stab	@T,3
	ret

initlbpbuffers
	jsr	initrxbuffer
	jsr	inittxbuffer
	ret

initrxbuffer
	ldib	rxbuffer&0FFh	; point X to rx buffer 
	stab	XL
	ldib	(rxbuffer>>8)&0FFh
	stab	XH		; 	
	ret
inittxbuffer
	ldib	txbuffer&0FFh	; point Y to tx buffer 
	stab	YL
	ldib	(txbuffer>>8)&0FFh
	stab	YH		; 	
	ret

inituarts
	ldab	defaulthsbrl
	stab	pktrxratel
	stab	pkttxratel
	ldab	defaulthsbrm
	stab	pktrxratem
	stab	pkttxratem
	ldab	defaulthsbrh
	stab	pktrxrateh
	stab	pkttxrateh
	ldib	000h
	stab	pkttxframeto	; no interframe delay on xmit
	ldib	001h
	stab	pktrxstatus	; clear rx uart
	stab	pkttxstatus	; clear tx uart
	ldib	040h		; set txen bit		
	stab	pkttxmode
	ldib	008h		; set rxen bit		
	stab	pktrxmode
initrxto
	ldab	lbpcommandto	
	stab	pktrxframeto	
	ret


initrpcdatabase

	ldib	hwmode0&0FFh	; store address of hwmode 0 GTOC entry 0
	stab	m0gtoc0+0	; 
	ldib	(hwmode0>>8)&0FFH
	stab	m0gtoc0+1

	ldib	swmode0&0FFh	; store address of swmode 0 GTOC entry 1
	stab	m0gtoc0+2	; 
	ldib	(swmode0>>8)&0FFH
	stab	m0gtoc0+3

	ldib	m0gdd0&0FFh	; store address of GDD0 0 to GTOC entry 2
	stab	m0gtoc0+4	; 
	ldib	(m0gdd0>>8)&0FFH
	stab	m0gtoc0+5

	ldib	m0gdd1&0FFh	; store address of GDD0 1 to GTOC entry 3
	stab	m0gtoc0+6	; 
	ldib	(m0gdd1>>8)&0FFH
	stab	m0gtoc0+7

	ldib	m0gdd2&0FFh	; store address of GDD0 2 to GTOC entry 4
	stab	m0gtoc0+8	; 
	ldib	(m0gdd2>>8)&0FFH
	stab	m0gtoc0+9

	ldib	m0gdd3&0FFh	; store address of GDD0 3 to GTOC entry 5
	stab	m0gtoc0+10	; 
	ldib	(m0gdd3>>8)&0FFH
	stab	m0gtoc0+11

	ldib	m0gdd4&0FFh	; store address of GDD0 4 to GTOC entry 6
	stab	m0gtoc0+12	; 
	ldib	(m0gdd4>>8)&0FFH
	stab	m0gtoc0+13

	ldib	0	
	stab	m0gtoc0+14	; last GTOC entry is zero
	stab	m0gtoc0+15

; these could be more compactly coded...
mode0gddrec0
	ldib	m0gdd0&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd0>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc0mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc0mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'0'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec1
	ldib	m0gdd1&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd1>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc1mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc1mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'1'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec2
	ldib	m0gdd2&0FFh	; point T to m0gdd0 
	stab	TL
	ldib	(m0gdd2>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	8		; 8 bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	enc2mode&0FFh	;transfer data address
	stab	@T,12
	ldib	(enc2mode>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'E'
	stab	@T,18
	ldib	'n'
	stab	@T,19
	ldib	'c'
	stab	@T,20
	ldib	'2'
	stab	@T,21
	ldib	'm'
	stab	@T,22
	ldib	'o'
	stab	@T,23
	ldib	'd'
	stab	@T,24
	ldib	'e'
	stab	@T,25
	ldib	0		; terminate
	stab	@T,26
	ldib	0
	stab	@T,27

mode0gddrec3
	ldib	m0gdd3&0FFh	; point T to m0gdd4 
	stab	TL
	ldib	(m0gdd3>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	swrevision&0FFh	;transfer data address
	stab	@T,12
	ldib	(swrevision>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	's'
	stab	@T,18
	ldib	'w'
	stab	@T,19
	ldib	'r'
	stab	@T,20
	ldib	'e'
	stab	@T,21
	ldib	'v'
	stab	@T,22
	ldib	'i'
	stab	@T,23
	ldib	's'
	stab	@T,24
	ldib	'i'
	stab	@T,25
	ldib	'o'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	0		; terminate
	stab	@T,28
	ldib	0
	stab	@T,29

mode0gddrec4
	ldib	m0gdd4&0FFh	; point T to m0gdd5 
	stab	TL
	ldib	(m0gdd4>>8)&0FFh
	stab	TH		; 	
	nop
	nop
	nop
	ldib	0A0h
	stab	@T,0		; global data descriptor record
	ldib	16		; 16bits
	stab	@T,1
	ldib	ddunsignedtype	; type 2 = unsigned
	stab	@T,2
	ldib	dddirectionout	; output
	stab	@T,3
	ldib	0
	stab	@T,4	; param_min = unused
	stab	@T,5
	stab	@T,6
	stab	@T,7
	stab	@T,8	; param_max = unused
	stab	@T,9
	stab	@T,10
	stab	@T,11
	ldib	hwrevision&0FFh	;transfer data address
	stab	@T,12
	ldib	(hwrevision>>8)&0FFH
	stab	@T,13
	ldib	'b'
	stab	@T,14
	ldib	'i'
	stab	@T,15
	ldib	't'
	stab	@T,16
	ldib	0
	stab	@T,17
	ldib	'h'
	stab	@T,18
	ldib	'w'
	stab	@T,19
	ldib	'r'
	stab	@T,20
	ldib	'e'
	stab	@T,21
	ldib	'v'
	stab	@T,22
	ldib	'i'
	stab	@T,23
	ldib	's'
	stab	@T,24
	ldib	'i'
	stab	@T,25
	ldib	'o'
	stab	@T,26
	ldib	'n'
	stab	@T,27
	ldib	0		; terminate
	stab	@T,28
	ldib	0
	stab	@T,29

	ldib	hwmode0&0FFh	; store address of hwmode 0 PTOC entry 0
	stab	m0ptoc0+0	; 
	ldib	(hwmode0>>8)&0FFH
	stab	m0ptoc0+1

	ldib	swmode0&0FFh	; store address of swmode 0 PTOC entry 1
	stab	m0ptoc0+2	; 
	ldib	(swmode0>>8)&0FFH
	stab	m0ptoc0+3

	ldib	m0pdd0&0FFh	; store address of PDD0 in PTOC entry 2 
	stab	m0ptoc0+4	; (PDD 0 is mode 0 input bits 0..23)    
	ldib	(m0pdd0>>8)&0FFH                                        
	stab	m0ptoc0+5                                               

	ldib	m0pdd1&0FFh	; store address of PDD1 in PTOC entry 3 
	stab	m0ptoc0+6	; (PDD 0 is mode 0 input bits 24..47)
	ldib	(m0pdd1>>8)&0FFH                                        
	stab	m0ptoc0+7                                               

	ldib	m0pdd2&0FFh	; store address of PDD2 in PTOC entry 4 
	stab	m0ptoc0+8	; (PDD 2 is mode 0 input bits 48..71)  
	ldib	(m0pdd2>>8)&0FFH                                        
	stab	m0ptoc0+9                                               

	ldib	m0pdd3&0FFh	; store address of PDD3 in PTOC entry 5 
	stab	m0ptoc0+10	; (PDD 3 is mode 0 output bits 0..23)  
	ldib	(m0pdd3>>8)&0FFH                                        
	stab	m0ptoc0+11                                              

	ldib	m0pdd4&0FFh	; store address of PDD4 in PTOC entry 6 
	stab	m0ptoc0+12	; (PDD 4 is mode 0 output bits 24..47)
	ldib	(m0pdd4>>8)&0FFH                                        
	stab	m0ptoc0+13                                              

	ldib	m0pdd5&0FFh	; store address of PDD5 in PTOC entry 7 
	stab	m0ptoc0+14	; (PDD 5 is mode 0 output bits 48..71)   
	ldib	(m0pdd5>>8)&0FFH                                        
	stab	m0ptoc0+15                                              

	ldib	m0pdd6&0FFh	; store address of PDD6 in PTOC entry 8 
	stab	m0ptoc0+16	; (PDD 6 is mode 0 Enc0 count)  
	ldib	(m0pdd6>>8)&0FFH                                        
	stab	m0ptoc0+17                                              

	ldib	m0pdd7&0FFh	; store address of PDD7 in PTOC entry 9 
	stab	m0ptoc0+18	; (PDD 7 is mode 0 Enc1 count)   
	ldib	(m0pdd7>>8)&0FFH
	stab	m0ptoc0+19

	ldib	m0pdd8&0FFh	; store address of PDD8 in PTOC entry 10
	stab	m0ptoc0+20	; (PDD 8 is mode 0 Enc2 count)   
	ldib	(m0pdd8>>8)&0FFH
	stab	m0ptoc0+21

	ldib	0	
	stab	m0ptoc0+22	; last PTOC entry is zero               
	stab	m0ptoc0+23

mode0hwmoderec0
	ldib	0B0h		; mode record type
	stab	hwmode0+0
	ldib	0		; mode index
	stab	hwmode0+1
	ldib	0		; mode type = hw
	stab	hwmode0+2
	ldib	0
	stab	hwmode0+3	; unused
	ldib	's'		; mode name string
	stab	hwmode0+4	
	ldib	't'		
	stab	hwmode0+5	
	ldib	'a'		
	stab	hwmode0+6	
	ldib	'n'		
	stab	hwmode0+7	
	ldib	'd'		
	stab	hwmode0+8	
	ldib	'a'		
	stab	hwmode0+9	
	ldib	'r'		
	stab	hwmode0+10	
	ldib	'd'		
	stab	hwmode0+11	
	ldib	0		;terminator		
	stab	hwmode0+12	

mode0swmoderec0
	ldib	0B0h		; mode record type
	stab	swmode0+0
	ldib	0		; mode index
	stab	swmode0+1
	ldib	1		; mode type = sw
	stab	swmode0+2
	ldib	0
	stab	swmode0+3	; unused
	ldib	's'		; mode name string
	stab	swmode0+4	
	ldib	't'		
	stab	swmode0+5	
	ldib	'a'		
	stab	swmode0+6	
	ldib	'n'		
	stab	swmode0+7	
	ldib	'd'		
	stab	swmode0+8	
	ldib	'a'		
	stab	swmode0+9	
	ldib	'r'		
	stab	swmode0+10	
	ldib	'd'		
	stab	swmode0+11	
	ldib	0		; terminator
	stab	swmode0+12	

mode0pddrec0
	ldib	0A0h
	stab	m0pdd0+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd0+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd0+2
	ldib	dddirectionin	; input
	stab	m0pdd0+3
	ldib	0
	stab	m0pdd0+4	; param_min = unused
	stab	m0pdd0+5
	stab	m0pdd0+6
	stab	m0pdd0+7
	stab	m0pdd0+8	; param_max = unused
	stab	m0pdd0+9
	stab	m0pdd0+10
	stab	m0pdd0+11
	ldib	hm2input0&0FFh	;hm2output data address
	stab	m0pdd0+12
	ldib	(hm2input0>>8)&0FFH
	stab	m0pdd0+13
	ldib	'b'
	stab	m0pdd0+14
	ldib	'i'
	stab	m0pdd0+15
	ldib	't'
	stab	m0pdd0+16
	ldib	0
	stab	m0pdd0+17
	ldib	'P'
	stab	m0pdd0+18
	ldib	'1'
	stab	m0pdd0+19
	ldib	'-'
	stab	m0pdd0+20
	ldib	'I'
	stab	m0pdd0+21
	ldib	'n'
	stab	m0pdd0+22
	ldib	0
	stab	m0pdd0+23

mode0pddrec1
	ldib	0A0h
	stab	m0pdd1+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd1+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd1+2
	ldib	dddirectionin	; input
	stab	m0pdd1+3
	ldib	0
	stab	m0pdd1+4	; param_min = unused
	stab	m0pdd1+5
	stab	m0pdd1+6
	stab	m0pdd1+7
	stab	m0pdd1+8	; param_max = unused
	stab	m0pdd1+9
	stab	m0pdd1+10
	stab	m0pdd1+11
	ldib	hm2input1&0FFh	;hm2output data address
	stab	m0pdd1+12
	ldib	(hm2input1>>8)&0FFH
	stab	m0pdd1+13
	ldib	'b'
	stab	m0pdd1+14
	ldib	'i'
	stab	m0pdd1+15
	ldib	't'
	stab	m0pdd1+16
	ldib	0
	stab	m0pdd1+17
	ldib	'P'
	stab	m0pdd1+18
	ldib	'2'
	stab	m0pdd1+19
	ldib	'-'
	stab	m0pdd1+20
	ldib	'I'
	stab	m0pdd1+21
	ldib	'n'
	stab	m0pdd1+22
	ldib	0
	stab	m0pdd1+23

mode0pddrec2
	ldib	0A0h
	stab	m0pdd2+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd2+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd2+2
	ldib	dddirectionin	; input
	stab	m0pdd2+3
	ldib	0
	stab	m0pdd2+4	; param_min = unused
	stab	m0pdd2+5
	stab	m0pdd2+6
	stab	m0pdd2+7
	stab	m0pdd2+8	; param_max = unused
	stab	m0pdd2+9
	stab	m0pdd2+10
	stab	m0pdd2+11
	ldib	hm2input2&0FFh	;hm2output data address
	stab	m0pdd2+12
	ldib	(hm2input2>>8)&0FFH
	stab	m0pdd2+13
	ldib	'b'
	stab	m0pdd2+14
	ldib	'i'
	stab	m0pdd2+15
	ldib	't'
	stab	m0pdd2+16
	ldib	0
	stab	m0pdd2+17
	ldib	'P'
	stab	m0pdd2+18
	ldib	'3'
	stab	m0pdd2+19
	ldib	'-'
	stab	m0pdd2+20
	ldib	'I'
	stab	m0pdd2+21
	ldib	'n'
	stab	m0pdd2+22
	ldib	0
	stab	m0pdd2+23

mode0pddrec3
	ldib	0A0h
	stab	m0pdd3+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd3+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd3+2
	ldib	dddirectionout	; output
	stab	m0pdd3+3
	ldib	0
	stab	m0pdd3+4	; param_min = unused
	stab	m0pdd3+5
	stab	m0pdd3+6
	stab	m0pdd3+7
	stab	m0pdd3+8	; param_max = unused
	stab	m0pdd3+9
	stab	m0pdd3+10
	stab	m0pdd3+11
	ldib	hm2output0&0FFh	;hm2output data address
	stab	m0pdd3+12
	ldib	(hm2output0>>8)&0FFH
	stab	m0pdd3+13
	ldib	'b'
	stab	m0pdd3+14
	ldib	'i'
	stab	m0pdd3+15
	ldib	't'
	stab	m0pdd3+16
	ldib	0
	stab	m0pdd3+17
	ldib	'P'
	stab	m0pdd3+18
	ldib	'1'
	stab	m0pdd3+19
	ldib	'-'
	stab	m0pdd3+20
	ldib	'O'
	stab	m0pdd3+21
	ldib	'u'
	stab	m0pdd3+22
	ldib	't'
	stab	m0pdd3+23
	ldib	0
	stab	m0pdd3+24

mode0pddrec4
	ldib	0A0h
	stab	m0pdd4+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd4+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd4+2
	ldib	dddirectionout	; output
	stab	m0pdd4+3
	ldib	0
	stab	m0pdd4+4	; param_min = unused
	stab	m0pdd4+5
	stab	m0pdd4+6
	stab	m0pdd4+7
	stab	m0pdd4+8	; param_max = unused
	stab	m0pdd4+9
	stab	m0pdd4+10
	stab	m0pdd4+11
	ldib	hm2output1&0FFh	;hm2output data address
	stab	m0pdd4+12
	ldib	(hm2output1>>8)&0FFH
	stab	m0pdd4+13
	ldib	'b'
	stab	m0pdd4+14
	ldib	'i'
	stab	m0pdd4+15
	ldib	't'
	stab	m0pdd4+16
	ldib	0
	stab	m0pdd4+17
	ldib	'P'
	stab	m0pdd4+18
	ldib	'2'
	stab	m0pdd4+19
	ldib	'-'
	stab	m0pdd4+20
	ldib	'O'
	stab	m0pdd4+21
	ldib	'u'
	stab	m0pdd4+22
	ldib	't'
	stab	m0pdd4+23
	ldib	0
	stab	m0pdd4+24

mode0pddrec5
	ldib	0A0h
	stab	m0pdd5+0	; process data descriptor record
	ldib	24		; 24 bits
	stab	m0pdd5+1
	ldib	ddbittype	; type 1 = bits
	stab	m0pdd5+2
	ldib	dddirectionout	; output
	stab	m0pdd5+3
	ldib	0
	stab	m0pdd5+4	; param_min = unused
	stab	m0pdd5+5
	stab	m0pdd5+6
	stab	m0pdd5+7
	stab	m0pdd5+8	; param_max = unused
	stab	m0pdd5+9
	stab	m0pdd5+10
	stab	m0pdd5+11
	ldib	hm2output2&0FFh	;hm2output data address
	stab	m0pdd5+12
	ldib	(hm2output2>>8)&0FFH
	stab	m0pdd5+13
	ldib	'b'
	stab	m0pdd5+14
	ldib	'i'
	stab	m0pdd5+15
	ldib	't'
	stab	m0pdd5+16
	ldib	0
	stab	m0pdd5+17
	ldib	'P'
	stab	m0pdd5+18
	ldib	'3'
	stab	m0pdd5+19
	ldib	'-'
	stab	m0pdd5+20
	ldib	'O'
	stab	m0pdd5+21
	ldib	'u'
	stab	m0pdd5+22
	ldib	't'
	stab	m0pdd5+23
	ldib	0
	stab	m0pdd5+24

mode0pddrec6
	ldib	0A0h
	stab	m0pdd6+0	; process data descriptor record
	ldib	8		; 8 bits
	stab	m0pdd6+1
	ldib	ddcounttype	; type 8 = count
	stab	m0pdd6+2
	ldib	dddirectionin	; input
	stab	m0pdd6+3
	ldib	0
	stab	m0pdd6+4	; param_min = unused
	stab	m0pdd6+5
	stab	m0pdd6+6
	stab	m0pdd6+7
	stab	m0pdd6+8	; param_max = unused
	stab	m0pdd6+9
	stab	m0pdd6+10
	stab	m0pdd6+11
	ldib	encoder0&0FFh	;transfer data address
	stab	m0pdd6+12
	ldib	(encoder0>>8)&0FFH
	stab	m0pdd6+13
	ldib	'c'
	stab	m0pdd6+14
	ldib	'o'
	stab	m0pdd6+15
	ldib	'u'
	stab	m0pdd6+16
	ldib	'n'
	stab	m0pdd6+17
	ldib	't'
	stab	m0pdd6+18
	ldib	0
	stab	m0pdd6+19
	ldib	'e'
	stab	m0pdd6+20
	ldib	'n'
	stab	m0pdd6+21
	ldib	'c'
	stab	m0pdd6+22
	ldib	'0'
	stab	m0pdd6+23
	ldib	0
	stab	m0pdd6+24

mode0pddrec7
	ldib	0A0h
	stab	m0pdd7+0	; process data descriptor record
	ldib	8		; 8 bits
	stab	m0pdd7+1
	ldib	ddcounttype	; type 8 = count
	stab	m0pdd7+2
	ldib	dddirectionin	; input
	stab	m0pdd7+3
	ldib	0
	stab	m0pdd7+4	; param_min = unused
	stab	m0pdd7+5
	stab	m0pdd2+6
	stab	m0pdd7+7
	stab	m0pdd7+8	; param_max = unused
	stab	m0pdd7+9
	stab	m0pdd7+10
	stab	m0pdd7+11
	ldib	encoder1&0FFh	;transfer data address
	stab	m0pdd7+12
	ldib	(encoder1>>8)&0FFH
	stab	m0pdd7+13
	ldib	'c'
	stab	m0pdd7+14
	ldib	'o'
	stab	m0pdd7+15
	ldib	'u'
	stab	m0pdd7+16
	ldib	'n'
	stab	m0pdd7+17
	ldib	't'
	stab	m0pdd7+18
	ldib	0
	stab	m0pdd7+19
	ldib	'E'
	stab	m0pdd7+20
	ldib	'n'
	stab	m0pdd7+21
	ldib	'c'
	stab	m0pdd7+22
	ldib	'1'
	stab	m0pdd7+23
	ldib	0
	stab	m0pdd7+24

mode0pddrec8
	ldib	0A0h
	stab	m0pdd8+0	; process data descriptor record
	ldib	8		; 8 bits
	stab	m0pdd8+1
	ldib	ddcounttype	; type 8 = count
	stab	m0pdd8+2
	ldib	dddirectionin	; input
	stab	m0pdd8+3
	ldib	0
	stab	m0pdd8+4	; param_min = unused
	stab	m0pdd8+5
	stab	m0pdd8+6
	stab	m0pdd8+7
	stab	m0pdd8+8	; param_max = unused
	stab	m0pdd8+9
	stab	m0pdd8+10
	stab	m0pdd8+11
	ldib	encoder2&0FFh	;transfer data address
	stab	m0pdd8+12
	ldib	(encoder2>>8)&0FFH
	stab	m0pdd8+13
	ldib	'c'
	stab	m0pdd8+14
	ldib	'o'
	stab	m0pdd8+15
	ldib	'u'
	stab	m0pdd8+16
	ldib	'n'
	stab	m0pdd8+17
	ldib	't'
	stab	m0pdd8+18
	ldib	0
	stab	m0pdd8+19
	ldib	'E'
	stab	m0pdd8+20
	ldib	'n'
	stab	m0pdd8+21
	ldib	'c'
	stab	m0pdd8+22
	ldib	'2'
	stab	m0pdd8+23
	ldib	0
	stab	m0pdd8+24
	ret
	
initdiscovery
	ldib	0
	subb	lbpremswmode
	jmpz	mode0init
	ldib	1
	subb	lbpremswmode
	jmpz	mode1init
	
mode0init
	ldib	m0ptoc0&0FFh	; process TOC 
	stab	rpcptoc+0
	ldib	(m0ptoc0>>8)&0FFH	
	stab	rpcptoc+1
	ldib	m0gtoc0&0FFh	; global TOC 
	stab	rpcgtoc+0
	ldib	(m0gtoc0>>8)&0FFH
	stab	rpcgtoc+1
	ldib	13
	stab	rpctxsize
	ldib	9
	stab	rpcrxsize
	ret
mode1init
	ret

inithm2
	jsr	clrddrs
	jsr	initinm
	ret

initinm			
				; first inm
	ldib	020h		; global inv 
	stab	hm2data0
	ldib	086h		; ~1 mhz, 8 scans fast time ~192 usec
	stab	hm2data1	;
	ldib	000h	
	stab	hm2data2
	ldib	005h		; 40 scans slow time ~5 ms
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	085h		; inm 0 control reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	000h		; setup filter register
	stab	hm2data0
	ldib	0FFh		; fast on all 8 
	stab	hm2data1
	ldib	000h			
	stab	hm2data2
	ldib	000h	
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	086h		; inmux 0 filter reg
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret

initparams
	ldib	enc0mode&0FFh	; point T to enc0mode 
	stab	TL
	ldib	(enc0mode>>8)&0FFh
	stab	TH		; 	
	ldib	0
	nop
	nop
	stab	@T,0
	stab	@T,1
	stab	@T,2
	stab	@T,3
	ret