parsepacket
	jsr	initlbpbuffers	
parsestart
	ldab	@X		; get command byte
	stab	lbpcommand
	ldib	lbpcommask	; valid command?
	andb	@X
	stab	lbpcomonly
	addix	1		; skip over command 
	jmpz	lbpparseerr	; no command so parse error
	ldib	lbprwcom	
	subb	lbpcomonly
	jmpnz	lbpnoaddr	; local or RPC so no address
	ldib	lbpaddrszmask
	andb	lbpcommand
	jmpz	lbpnoaddr	; no address in R/W command so use current
	ldab	@X,0		; get address
	stab	lbpaddrlow	
	ldab	@X,1			
	stab	lbpaddrhigh
	addix	2		; skip over address
lbpnoaddr
	ldib	lbplocal
	subb	lbpcomonly
	jmpz	parselocal	; local commands
	ldib	lbprpc
	subb	lbpcomonly
	jmpz	parserpc	; rpc commands
	ldib	lbpsizemask
	andb	lbpcommand
	stab	lbprwsize	
	ldib	lbpextmemcode	;0xEE
	subb	lbpmemspace	; default 0
	stab	lbpextmem	; zero if ext mem access	
	ldib	lbpwritemask	; fall through to read/write
	andb	lbpcommand
	jmpz	lbpread
lbpwrite
	ldab	lbpextmem
	jmpz	lbpwriteext			
	ldib	1	
	subb	lbpaddrhigh	; check for < 512
	jmpnc	lbpinvalidaddrerr
	ldib	7		; check for > 2047
	subb	lbpaddrhigh
	jmpc	lbpinvalidaddrerr
	ldab	lbpaddrlow
	stab	ZL		; 0 through 2047
	ldab	lbpaddrhigh
	stab	ZH	
	ldib	lbpsize64
	subb	lbprwsize
	jmpz	lbpwrite64
	ldib	lbpsize32
	subb	lbprwsize
	jmpz	lbpwrite32
	ldib	lbpsize16
	subb	lbprwsize
	jmpz	lbpwrite16
lbpwrite8
	ldab	@X,0
	stab	@Z,0
	ldab	1
	stab	lbpaddrinc
	addix	1
	jmp	lbpwdone
lbpwrite16
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	2
	stab	lbpaddrinc
	addix	2
	jmp	lbpwdone
lbpwrite32
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	@X,2
	stab	@Z,2
	ldab	@X,3
	stab	@Z,3
	ldab	4
	stab	lbpaddrinc
	addix	4
	jmp	lbpwdone
lbpwrite64
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	@X,2
	stab	@Z,2
	ldab	@X,3
	stab	@Z,3
	ldab	@X,4
	stab	@Z,4
	ldab	@X,5
	stab	@Z,5
	ldab	@X,6
	stab	@Z,6
	ldab	@X,7
	stab	@Z,7
	ldib	8
	stab	lbpaddrinc
	addix	8
	jmp	lbpwdone
lbpwriteext
	ldib	lbpsize32
	subb	lbprwsize
	jmpnz	lbpparseerr	; anything but 32 bit is unsupported
	ldab	lbpaddrlow
	stab	hm2addr0			
	ldab	lbpaddrhigh
	stab	hm2addr1			
	ldab	@X,0
	stab	hm2data0
	ldab	@X,1
	stab	hm2data1
	ldab	@X,2
	stab	hm2data2
	ldab	@X,3
	stab	hm2data3
	stab	hm2startwrite
	ldab	4
	stab	lbpaddrinc
	addix	4
	jmp	lbprwdone		
lbpread
	ldab	lbpextmem
	jmpz	lbpreadext
	ldib	1	
	subb	lbpaddrhigh	; error if addrhigh < 2 (below 512)
	jmpnc	lbpinvalidaddrerr
	ldib	7		; error if addrhigh > 7 (above 2047)
	subb	lbpaddrhigh
	jmpc	lbpinvalidaddrerr
	ldab	lbpaddrlow
	stab	ZL		; 512 through 2047		
	ldab	lbpaddrhigh
	stab	ZH
	ldib	lbpsize64
	subb	lbprwsize
	jmpz	lbpread64
	ldib	lbpsize32
	subb	lbprwsize
	jmpz	lbpread32
	ldib	lbpsize16
	subb	lbprwsize
	jmpz	lbpread16
lbpread8
	ldab	@Z,0
	stab	@Y,0
	ldib	1
	stab	lbpaddrinc
	addiy	1	
	jmp	lbprwdone		
lbpread16
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldib	2
	stab	lbpaddrinc
	addiy	2	
	jmp	lbprwdone		
lbpread32
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldab	@Z,2
	stab	@Y,2
	ldab	@Z,3
	stab	@Y,3
	ldib	4
	stab	lbpaddrinc
	addiy	4	
	jmp	lbprwdone		
lbpread64
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldab	@Z,2
	stab	@Y,2
	ldab	@Z,3
	stab	@Y,3
	ldab	@Z,4
	stab	@Y,4
	ldab	@Z,5
	stab	@Y,5
	ldab	@Z,6
	stab	@Y,6
	ldab	@Z,7
	stab	@Y,7
	ldib	8
	stab	lbpaddrinc
	addiy	8	
	jmp	lbprwdone		
lbpreadext
	ldab	lbpaddrlow
	stab	hm2addr0			
	ldab	lbpaddrhigh
	stab	hm2addr1			
	stab	hm2startread	
	ldib	lbpsize32
	subb	lbprwsize
	jmpnz	lbpparseerr	; anything but 32 bit is unsupported
	ldib	4
	stab	lbpaddrinc
	addiy	4	
	jmp	lbprwdone		

parselocal
	ldib	lbplocaladdmask	; extract local address
	andb	lbpcommand	; and make pointer to local memory
	addb	lbplocalmemptr
	stab	ZL
	ldib	0
	stab	ZH
	ldib	lbpwritemask	; fall through to read/write
	andb	lbpcommand
	jmpz	lbpreadlocal
lbpwritelocal
	ldib	lbplocalro	; the FX region, mostly RO
	andb	lbpcommand
	jmpnz	lbpwritelocalf
lbpwritelocale
	ldab	@X		; the EX region all R/W
	stab	@Z		;
	addix	1
	ldib	lbpsetcomtocom	; if this is a set command/frame timeout
	subb	lbpcommand	; write, we need to update the hardware
	jmpz	setlbpcommandto	; were done
	nop
	nop
	jmp	lbpdone
setlbpcommandto
	ldab	lbpcommandto	; update hardware	
	stab	pktrxframeto	
	jmp	lbpdone
lbpwritelocalf				; only a few local write targets here
	ldib	lbpsetledscom
	subb	lbpcommand
	jmpz	lbpsetleds
	ldib	lbpsetaddrlowcom
	subb	lbpcommand
	jmpz	lbpsetaddrlow
	ldib	lbpsetaddrhighcom
	subb	lbpcommand
	jmpz	lbpsetaddrhigh
	ldib	lbpincaddrcom
	subb	lbpcommand
	jmpz	lbpincaddress
	ldib	lbpresetproccom
	subb	lbpcommand
	jmpz	lbpresetproc
	ldib	lbpresetparsercom
	subb	lbpcommand
	jmpz	lbpresetparser
	addix	1		; for all the ro cases, skip the data
	jmp	lbpdone

lbpsetleds
	ldab	@X
;	stab	localleds	; local leds are use for blinker ATM
	stab	lbpleds		; shadow
	addix	1
	jmp	lbpdone	

lbpsetaddrlow
	ldab	@X
	stab	lbpaddrlow
	addix	1
	jmp	lbpdone	

lbpsetaddrhigh
	ldab	@X
	stab	lbpaddrhigh
	addix	1
	jmp	lbpdone	

lbpincaddress
	addb	zeroloc		; clear carry
	ldab	@X
	addtob	lbpaddrlow
	ldib	0
	addctob	lbpaddrhigh
	addix	1
	jmp	lbpdone	

lbpresetproc
	ldab	@X
	subb	lbpcookie
	jmpnz	lbpnoreset
	nop
	nop
	jmp	start
lbpnoreset
	addix	1
	jmp	lbpdone

lbpresetparser
	jsr	initlbpbuffers
	ldib	0
	ret

lbpreadlocal
	ldab	@Z
	stab	@Y
	addiy	1
	jmp	lbpdone

parserpc
	ldib	processdatarpc
	subb	lbpcommand
	jmpz	xferprocessdata
	ldib	unitnumberrpc		
	subb	lbpcommand
	jmpz	sendunitnumber
	ldib	discoveryrpc		
	subb	lbpcommand
	jmpz	senddiscoverdata
	nop
	nop
	jmp	lbpdone		; just no-op for unsupported RPCs	

xferprocessdata
mode0_0xfer	

mode0x0_read
	ldib	00h
	stab	hm2addr0
	ldib	10h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	ldab	lbpremfault
	stab	@Y,0	
	ldab	hm2data0
	xorb	minusoneloc
	stab	@Y,1	
	ldab	hm2data1
	xorb	minusoneloc
	stab	@Y,2	
	ldab	hm2data2
	xorb	minusoneloc
	stab	@Y,3	
	ldib	04h
	stab	hm2addr0
	ldib	10h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data0
	xorb	minusoneloc
	stab	@Y,4	
	ldab	hm2data1
	xorb	minusoneloc
	stab	@Y,5	
	ldab	hm2data2
	xorb	minusoneloc
	stab	@Y,6	
	ldib	08h
	stab	hm2addr0
	ldib	10h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data0
	xorb	minusoneloc
	stab	@Y,7	
	ldab	hm2data1
	xorb	minusoneloc
	stab	@Y,8	
	ldab	hm2data2
	xorb	minusoneloc
	stab	@Y,9	

	ldib	00h		; then the 3 MPG encoders
	stab	hm2addr0
	ldib	89h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data0
	stab	@Y,10	
	ldab	hm2data1
	stab	@Y,11	
	ldab	hm2data2
	stab	@Y,12	
	addiy	13

mode0_0write
	ldab	lbpremfault
	jmpnz	mode0_0skipwrite
	ldib	00h
	stab	hm2addr0
	ldib	11h		; in mode 0 we use active low open drain mode
	stab	hm2addr1	; so write output data to DDR
	ldab	@X,0		; this depends ot the output latches being 
	stab	hm2data0	; cleared to all 0's during init
	ldab	@X,1
	stab	hm2data1
	ldab	@X,2
	stab	hm2data2
	stab	hm2startwrite
;	nop
;	nop
;	nop
;	nop
	ldib	04h
	stab	hm2addr0
	ldib	11h
	stab	hm2addr1
	ldab	@X,3
	stab	hm2data0
	ldab	@X,4
	stab	hm2data1
	ldab	@X,5
	stab	hm2data2
	stab	hm2startwrite
;	nop
;	nop
;	nop
;	nop
	ldib	08h
	stab	hm2addr0
	ldib	11h
	stab	hm2addr1
	ldab	@X,6
	stab	hm2data0
	ldab	@X,7
	stab	hm2data1
	ldab	@X,8
	stab	hm2data2
	stab	hm2startwrite
mode0_0skipwrite
	addix	9
	jmp	lbpdone	


sendunitnumber
	ldab	rpcunitnumber
	stab	@Y,0		
	ldab	rpcunitnumber+1
	stab	@Y,1		
	ldab	rpcunitnumber+2
	stab	@Y,2		
	ldab	rpcunitnumber+3
	stab	@Y,3
	addiy	4		
	jmp	lbpdone
	
senddiscoverdata
	jsr	initdiscovery
	ldab	rpctxsize
	stab	@Y,0	
	ldab	rpcrxsize
	stab	@Y,1
	ldab	rpcptoc+0
	stab	@Y,2	
	ldab	rpcptoc+1
	stab	@Y,3	
	ldab	rpcgtoc+0
	stab	@Y,4	
	ldab	rpcgtoc+1
	stab	@Y,5	
	addiy	6
	jmp	lbpdone

lbpwdone	
	jsr	updatehardware	
lbprwdone
	ldib	lbpautoincmask	
	andb	lbpcommand
	jmpz	lbpdone		; no post inc
	addb	zeroloc		; clear carry
	ldab	lbpaddrinc
	addtob	lbpaddrlow	; 8 to 16 bit add
	ldib	0
	addctob	lbpaddrhigh
	jmp	lbpdone
	
lbpdone
	ldab	YL		; check xmit bytes (tx buffer starts at 384) 
	andb	txptrmask	; drop 80h offset from YL (so 0x0110 ) 
	stab	txpktsize		
	ldab	YH
	subb	oneloc		; > 01 in YH = 384  base address	
	jmpnz	lbpbufferr
	ldib	64		; maximum tx size is 64 bytes
	addb	zeroloc
	subb	txpktsize
	jmpc	lbpbufferr
	ldab	XL		;
	subb	rxpktsize
	jmpc	parsestart	; more to parse
	nop
	jsr	gettimestamp
	ldib	0		; good return
	ret


lbpinvalidaddrerr
	ldib	lbpinvalidaddrb
	ortob	lbpstatus
	jmp	lbpparseerr	
lbpbufferr
	ldib	lbpbufferrb
	ortob	lbpstatus
lbpparseerr
	ldib	0FFh		; bad return
	ret

gettimestamp
	ldab	timerlow		; save a timestamp for watchdog
	stab	parsegoodtime+0 
	ldab	timerhigh
	stab	parsegoodtime+1 
	ret

updatehardware
	ldib	enc0mode&0FFh	; point T to enc0mode 
	stab	TL
	ldib	(enc0mode>>8)&0FFh
	stab	TH		; 	
	ldib	000h
	stab	hm2addr0
	ldib	089h		; MPG registers
	stab	hm2addr1	; set modes	
	ldab	@T,0		
	stab	hm2data0	
	ldab	@T,1
	stab	hm2data1
	ldab	@T,2
	stab	hm2data2
	ldab	@T,3
	stab	hm2data3
	stab	hm2startwrite
	ret