
parsepacket
	jsr	initlbpbuffers	
parsestart
	ldab	@X		; get command byte
	stab	lbpcommand
	ldib	lbpcommask	; valid command?
	andb	@X
	stab	lbpcomonly
	addix	1		; skip over command 
	jmpz	lbpparseerr	; no command so parse error
	ldib	lbprwcom	
	subb	lbpcomonly
	jmpnz	lbpnoaddr	; local or RPC so no address
	ldib	lbpaddrszmask
	andb	lbpcommand
	jmpz	lbpnoaddr	; no address in R/W command so use current
	ldab	@X,0		; get address
	stab	lbpaddrlow	
	ldab	@X,1			
	stab	lbpaddrhigh
	addix	2		; skip over address
lbpnoaddr
	ldib	lbplocal
	subb	lbpcomonly
	jmpz	parselocal	; local commands
	ldib	lbprpc
	subb	lbpcomonly
	jmpz	parserpc	; rpc commands
	ldib	lbpsizemask
	andb	lbpcommand
	stab	lbprwsize	
	ldib	lbpextmemcode	;0xEE
	subb	lbpmemspace	; default 0
	stab	lbpextmem	; zero if ext mem access	
	ldib	lbpwritemask	; fall through to read/write
	andb	lbpcommand
	jmpz	lbpread
lbpwrite
	ldab	lbpextmem
	jmpz	lbpwriteext			
	ldib	1	
	subb	lbpaddrhigh	; check for < 512
	jmpnc	lbpinvalidaddrerr
	ldib	7		; check for > 2047
	subb	lbpaddrhigh
	jmpc	lbpinvalidaddrerr
	ldab	lbpaddrlow
	stab	ZL		; 0 through 2047
	ldab	lbpaddrhigh
	stab	ZH	
	ldib	lbpsize64
	subb	lbprwsize
	jmpz	lbpwrite64
	ldib	lbpsize32
	subb	lbprwsize
	jmpz	lbpwrite32
	ldib	lbpsize16
	subb	lbprwsize
	jmpz	lbpwrite16
lbpwrite8
	ldab	@X,0
	stab	@Z,0
	ldab	1
	stab	lbpaddrinc
	addix	1
	jmp	lbpwdone
lbpwrite16
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	2
	stab	lbpaddrinc
	addix	2
	jmp	lbpwdone
lbpwrite32
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	@X,2
	stab	@Z,2
	ldab	@X,3
	stab	@Z,3
	ldab	4
	stab	lbpaddrinc
	addix	4
	ldib	001h		; kludge to detect "EEPROM" write of nvunitnumber
	subb	lbpmemspace
	jmpz	writenvunit
	nop
	nop
	jmp	lbpwdone
lbpwrite64
	ldab	@X,0
	stab	@Z,0
	ldab	@X,1
	stab	@Z,1
	ldab	@X,2
	stab	@Z,2
	ldab	@X,3
	stab	@Z,3
	ldab	@X,4
	stab	@Z,4
	ldab	@X,5
	stab	@Z,5
	ldab	@X,6
	stab	@Z,6
	ldab	@X,7
	stab	@Z,7
	ldib	8
	stab	lbpaddrinc
	addix	8
	jmp	lbpwdone
lbpwriteext
	ldib	lbpsize32
	subb	lbprwsize
	jmpnz	lbpparseerr	; anything but 32 bit is unsupported
	ldab	lbpaddrlow
	stab	hm2addr0			
	ldab	lbpaddrhigh
	stab	hm2addr1			
	ldab	@X,0
	stab	hm2data0
	ldab	@X,1
	stab	hm2data1
	ldab	@X,2
	stab	hm2data2
	ldab	@X,3
	stab	hm2data3
	stab	hm2startwrite
	ldab	4
	stab	lbpaddrinc
	addix	4
	jmp	lbprwdone		
lbpread
	ldab	lbpextmem
	jmpz	lbpreadext
	ldib	1	
	subb	lbpaddrhigh	; error if addrhigh < 2 (below 512)
	jmpnc	lbpinvalidaddrerr
	ldib	7		; error if addrhigh > 7 (above 2047)
	subb	lbpaddrhigh
	jmpc	lbpinvalidaddrerr
	ldab	lbpaddrlow
	stab	ZL		; 512 through 2047		
	ldab	lbpaddrhigh
	stab	ZH
	ldib	lbpsize64
	subb	lbprwsize
	jmpz	lbpread64
	ldib	lbpsize32
	subb	lbprwsize
	jmpz	lbpread32
	ldib	lbpsize16
	subb	lbprwsize
	jmpz	lbpread16
lbpread8
	ldab	@Z,0
	stab	@Y,0
	ldib	1
	stab	lbpaddrinc
	addiy	1	
	jmp	lbprwdone		
lbpread16
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldib	2
	stab	lbpaddrinc
	addiy	2	
	jmp	lbprwdone		
lbpread32
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldab	@Z,2
	stab	@Y,2
	ldab	@Z,3
	stab	@Y,3
	ldib	4
	stab	lbpaddrinc
	addiy	4	
	jmp	lbprwdone		
lbpread64
	ldab	@Z,0
	stab	@Y,0
	ldab	@Z,1
	stab	@Y,1
	ldab	@Z,2
	stab	@Y,2
	ldab	@Z,3
	stab	@Y,3
	ldab	@Z,4
	stab	@Y,4
	ldab	@Z,5
	stab	@Y,5
	ldab	@Z,6
	stab	@Y,6
	ldab	@Z,7
	stab	@Y,7
	ldib	8
	stab	lbpaddrinc
	addiy	8	
	jmp	lbprwdone		
lbpreadext
	ldab	lbpaddrlow
	stab	hm2addr0			
	ldab	lbpaddrhigh
	stab	hm2addr1			
	stab	hm2startread	
	ldib	lbpsize32
	subb	lbprwsize
	jmpnz	lbpparseerr	; anything but 32 bit is unsupported
	ldib	4
	stab	lbpaddrinc
	addiy	4	
	jmp	lbprwdone		

parselocal
	ldib	lbplocaladdmask	; extract local address
	andb	lbpcommand	; and make pointer to local memory
	addb	lbplocalmemptr
	stab	ZL
	ldib	0
	stab	ZH
	ldib	lbpwritemask	; fall through to read/write
	andb	lbpcommand
	jmpz	lbpreadlocal
lbpwritelocal
	ldib	lbplocalro	; the FX region, mostly RO
	andb	lbpcommand
	jmpnz	lbpwritelocalf
lbpwritelocale
	ldab	@X		; the EX region all R/W
	stab	@Z		;
	addix	1
	ldib	lbpsetcomtocom	; if this is a set command/frame timeout
	subb	lbpcommand	; write, we need to update the hardware
	jmpz	setlbpcommandto	; were done
	nop
	nop
	jmp	lbpdone
setlbpcommandto
	ldab	lbpcommandto	; update hardware	
	stab	pktrxframeto	
	jmp	lbpdone
lbpwritelocalf				; only a few local write targets here
	ldib	lbpsetledscom
	subb	lbpcommand
	jmpz	lbpsetleds
	ldib	lbpsetaddrlowcom
	subb	lbpcommand
	jmpz	lbpsetaddrlow
	ldib	lbpsetaddrhighcom
	subb	lbpcommand
	jmpz	lbpsetaddrhigh
	ldib	lbpincaddrcom
	subb	lbpcommand
	jmpz	lbpincaddress
	ldib	lbpresetproccom
	subb	lbpcommand
	jmpz	lbpresetproc
	ldib	lbpresetparsercom
	subb	lbpcommand
	jmpz	lbpresetparser
	addix	1		; for all the ro cases, skip the data
	jmp	lbpdone

lbpsetleds
	ldab	@X
;	stab	localleds	; local leds are use for blinker ATM
	stab	lbpleds		; shadow
	addix	1
	jmp	lbpdone	

lbpsetaddrlow
	ldab	@X
	stab	lbpaddrlow
	addix	1
	jmp	lbpdone	

lbpsetaddrhigh
	ldab	@X
	stab	lbpaddrhigh
	addix	1
	jmp	lbpdone	

lbpincaddress
	addb	zeroloc		; clear carry
	ldab	@X
	addtob	lbpaddrlow
	ldib	0
	addctob	lbpaddrhigh
	addix	1
	jmp	lbpdone	

lbpresetproc
	ldab	@X
	subb	lbpcookie
	jmpnz	lbpnoreset
	nop
	nop
	jmp	start
lbpnoreset
	addix	1
	jmp	lbpdone

lbpresetparser
	jsr	initlbpbuffers
	ldib	0
	ret

lbpreadlocal
	ldab	@Z
	stab	@Y
	addiy	1
	jmp	lbpdone

parserpc
	ldib	processdatarpc
	subb	lbpcommand
	jmpz	xferprocessdata
	ldib	unitnumberrpc		
	subb	lbpcommand
	jmpz	sendunitnumber
	ldib	discoveryrpc		
	subb	lbpcommand
	jmpz	senddiscoverdata
	nop
	nop
	jmp	lbpdone		; just no-op for unsupported RPCs	

writenvunit
	ldib	0FFh	
	subb	rpcunitnumber+3
	jmpnz	writenvdone	; if not blank, do nothing
	jsr	finishfl	; finish any ops in progress
	ldib	000h
	stab	fladdr+0
	stab	fladdr+1
	ldib	01Fh
	stab	fladdr+2	; serial number is in last erase sector of 16 Mbit chip
	ldab	nvunitnumber+0	
	stab	fldata+0	
	ldab	nvunitnumber+1		
	stab	fldata+1
	ldab	nvunitnumber+2	
	stab	fldata+2
	ldab	nvunitnumber+3	
	stab	fldata+3
	jsr	writefl	
	jsr	finishfl
writenvdone
	jmp	lbpwdone	
	

xferprocessdata
mode0_0xfer	

mode0x0_read
	ldib	00h		; first the 48 inmux bits 24 at a time
	stab	hm2addr0
	ldib	82h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	ldab	lbpremfault
	stab	@Y,0	
	ldab	hm2data0
	stab	@Y,1	
	ldab	hm2data1
	stab	@Y,2	
	ldab	hm2data2
	stab	@Y,3	
	ldib	04h
	stab	hm2addr0
	ldib	82h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data0
	stab	@Y,4	
	ldab	hm2data1
	stab	@Y,5	
	ldab	hm2data2
	stab	@Y,6	

	ldib	00h		; then the 4 MPG encoders
	stab	hm2addr0
	ldib	84h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop

#IFDEF EIGHTBITMPGS
eightbitmpgs
	ldab	hm2data0
	stab	@Y,7	
	ldab	hm2data1
	stab	@Y,8	
	ldab	hm2data2
	stab	@Y,9	
	ldab	hm2data3
	stab	@Y,10	

	ldib	00h		; then the 2 Analog inputs (#0)
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
two_analog_inputs
	ldib	00h
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	

	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,11
	ldib	04h		; then the 2 Analog inputs (#1)
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,12
	addiy	13
#ENDIF EIGHTBITMPGS

#IFDEF FOURBITMPGS
fourbitmpgs
	ldib	00Fh
	andb	hm2data0	; low nibble is MPG 0
	stab	temp	
	ldab	hm2data1	; high nibble is MPG 1
	shln	
	nop	
	orb	temp
	stab	@Y,7	
	ldib	00Fh
	andb	hm2data2	; low nibble is MPG 2
	stab	temp	
	ldab	hm2data3	; high nibble is MPG 3
	shln	
	nop
	orb	temp
	stab	@Y,8	

four_analog_inputs
	ldib	00h		; analog input 0
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,9
	ldib	04h		; analog input 1)
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,10
	ldib	08h		; analog input 2)
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,11
	ldib	0Ch		; analog input 3)
	stab	hm2addr0
	ldib	90h
	stab	hm2addr1
	stab	hm2startread	
	nop
	nop
	nop
	nop
	ldab	hm2data1 	; msbyte of 16 bit data
	stab	@Y,12
	addiy	13
#ENDIF FOURBITMPGS

mode0_0write
	ldab	lbpremfault
	jmpnz	mode0_0skipwrite
	ldib	000h
	stab	hm2addr0
	ldib	07Dh		; write all SSRS
	stab	hm2addr1	
	ldab	@X,0		
	stab	hm2data0	
	ldab	@X,1
	stab	hm2data1
	ldab	@X,2
	stab	hm2data2
	stab	hm2startwrite
	nop
	nop
	nop
	nop
mode0_0skipwrite
	addix	3
	jmp	lbpdone	

sendunitnumber
	ldab	rpcunitnumber
	stab	@Y,0		
	ldab	rpcunitnumber+1
	stab	@Y,1		
	ldab	rpcunitnumber+2
	stab	@Y,2		
	ldab	rpcunitnumber+3
	stab	@Y,3
	addiy	4		
	jmp	lbpdone
	
senddiscoverdata
	jsr	initdiscovery
	ldab	rpctxsize
	stab	@Y,0	
	ldab	rpcrxsize
	stab	@Y,1
	ldab	rpcptoc+0
	stab	@Y,2	
	ldab	rpcptoc+1
	stab	@Y,3	
	ldab	rpcgtoc+0
	stab	@Y,4	
	ldab	rpcgtoc+1
	stab	@Y,5	
	addiy	6
	jmp	lbpdone

lbpwdone	
	jsr	updatehardware	
lbprwdone
	ldib	lbpautoincmask	
	andb	lbpcommand
	jmpz	lbpdone		; no post inc
	addb	zeroloc		; clear carry
	ldab	lbpaddrinc
	addtob	lbpaddrlow	; 8 to 16 bit add
	ldib	0
	addctob	lbpaddrhigh
	jmp	lbpdone
	
lbpdone
	ldab	YL		; check xmit bytes (tx buffer starts at 384) 
	andb	txptrmask	; drop 80h offset from YL (so 0x0110 ) 
	stab	txpktsize		
	ldab	YH
	subb	oneloc		; > 01 in YH = 384  base address	
	jmpnz	lbpbufferr
	ldib	64		; maximum tx size is 64 bytes
	addb	zeroloc
	subb	txpktsize
	jmpc	lbpbufferr
	ldab	XL		;
	subb	rxpktsize
	jmpc	parsestart	; more to parse
	nop
	jsr	gettimestamp
	ldib	0		; good return
	ret


lbpinvalidaddrerr
	ldib	lbpinvalidaddrb
	ortob	lbpstatus
	jmp	lbpparseerr	
lbpbufferr
	ldib	lbpbufferrb
	ortob	lbpstatus
lbpparseerr
	ldib	0FFh		; bad return
	ret

gettimestamp
	ldab	timerlow		; save a timestamp for watchdog
	stab	parsegoodtime+0 
	ldab	timerhigh
	stab	parsegoodtime+1 
	ret

updatehardware
	jsr	updateinmuxcr
	ldib	enc0mode&0FFh	; point T to enc0mode 
	stab	TL
	ldib	(enc0mode>>8)&0FFh
	stab	TH		; 	
	ldib	000h
	stab	hm2data0	; default is 0 = 1x mode
	stab	hm2data1
	stab	hm2data2
	stab	hm2data3
	stab	hm2addr0
	ldib	084h		; MPG registers
	stab	hm2addr1	; set modes	
	ldab	@T,0		
	jmpz	mpgmode1
	ldib	1
	stab	hm2data0	
mpgmode1	
	ldab	@T,1
	jmpz	mpgmode2
	ldib	1
	stab	hm2data1
mpgmode2	
	ldab	@T,2
	jmpz	mpgmode3
	ldib	1
	stab	hm2data2
mpgmode3
	ldab	@T,3
	jmpz	mpgmodewrite
	ldib	1
	stab	hm2data3
mpgmodewrite
	stab	hm2startwrite
	ret

