#include global.equ
#include ssremote.equ
#DEFINE FOURBITMPGS
;#DEFINE EIGHTBITMPGS


start
	nop	
	nop			; majik pipeline foo
	nop
	jsr	init		; initialize c+v	
				; then fall into host/process loop
	ldib	0FFh		;
	stab	localledmode
;	jsr	debugsetup
	;**************************************************************
mainloop
	ldab	timerlow	; latch 1 usec timer
	ldab	timerhigh	; top byte of us timer so 256 usec intervals	
	subb	parsegoodtime+1	; subtract timestamp	
	addb	zeroloc		; clear carry
	subb	wdtimeout	; 50 ms
	jmpc	nowatchdogfault		
	nop
	nop
	jsr	wdfault
nowatchdogfault	
	ldab	lbpremfault
	jmpz	nofaults
	ldib	0FFh
	stab	errorled
	ldib	0
	stab	localleds
	jmp	maincont
nofaults
	ldib	000h
	stab	errorled
	ldab	greencount+1
	rcrb
	stab	localleds	
maincont
	ldab	lbpclrremflt
	jmpz	nofaultstoclr
	nop
	nop
	jsr	clearfaults
nofaultstoclr
	ldib	01Fh		; check for any received packets
	andb 	pktrxstatus
	jmpz	mainloop	
	nop
	nop
	jsr	getpacket
	jmpnz	mainloop	; rx error if non zero
	nop
	nop
	jsr	parsepacket
	jmpnz	mainloop	; nothing to send or parse error if non zero
	nop
	nop
	jsr	putpacket
	jmp	mainloop

getpacket
	stab	settpreg0
	jsr	initrxbuffer
	ldib	03Fh	
	andb	pktrxdatacnt	; drop errors, data count only
	stab	loopiloc		
	stab	rxpktsize
	jmpz	rxnodata			
	stab	clrcrc		; clear crc hardware
	nop
getpktloop
	ldab	pktrxdata	; get rx data byte
	stab	crc		; crc check
	stab	@X		; save in rxbuffer
	ldib	0FFh
	addtob	loopiloc
	addix	1		; bump buffer ptr
	jmpnz	getpktloop
	nop
	nop
	ldib	1
	stab	pktrxstatus	; always clear rxuart after rx packet	
				; this forces a strict synchronous
				; packet dicipline but this is ok for SS
	ldab	lbpcrcen	; 0 crc is good
	jmpz	rxgood		; always good if not checking
	ldab	rxpktsize
	addb	minusoneloc	; drop crc char from count
	stab	rxpktsize
	ldab	crc
	jmpz	rxgood
	ldib	lbpcrcerrb	; crc error bit
	ortob	lbpstatus
	ldib	1
	addtob	lbpcrcerrcnt
rxnodata	
	ldib	0FFh
	ret
rxgood				; 0 acc = good
	ldib	1
	addtob	rxpktcount
	addb	zeroloc		; clear carry
	ldib	1
	addtob	greencount
	ldib	0
	addctob	greencount+1
	ldib	0	
	stab	clrtpreg0
	ret
	
putpacket
	jsr	inittxbuffer	; 
	stab	clrcrc		; 
	ldab	txpktsize
	jmpz	sendcrc		; no data so just send 0 crc
	ldib	1		; always clear txuart before send
	stab	pkttxstatus	; this forces a strict synchronous
	ldab	txpktsize	; packet dicipline but thats ok for SS
	stab	loopiloc
putpktloop
	ldab	@Y
	stab	crc
	stab	pkttxdata
	addiy	1
	ldib	0FFh
	addtob	loopiloc
	jmpnz	putpktloop
	nop
	nop
sendcrc
	ldab	lbpcrcen
	jmpz	nocrc
	ldab	crc		; send calculated CRC
	stab	pkttxdata
	ldib	1
	addb	txpktsize
	jmp	sendit
nocrc
	ldab	txpktsize
sendit
	jmpz	sendnodata	; is this needed? 
	stab	pkttxdatacnt	; not sure what UART does if pkt length is 0							
sendnodata
	ret	

clearfaults		; a dummy for now
	ldib	0
	stab	lbpclrremflt
	stab	lbpremfault
	jsr	fixddrs	
	ret

wdfault
	ldib	remwdfault
	ortob	lbpremfault
	; clear hardware	
mode0_0clr
	jsr	clrddrs
	jsr	initxfrmrs	;to clear the SSR output register
	jsr	initparams
	jsr	updatehardware
	ret

clrddrs
	ldib	0
	stab	hm2data0
	stab	hm2data1
	stab	hm2data2
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	011h
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	ldib	004h
	stab	hm2addr0
	ldib	011h
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret

fixddrs
	ldib	020h		; first set xfrmrs ref to inverted
	stab	hm2data0
	ldib	000h
	stab	hm2data1
	ldib	000h
	stab	hm2data2
	ldib	000h
	stab	hm2data3
	ldib	004h
	stab	hm2addr0
	ldib	014h
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	0FFh		; standard 7IA0 DDRs
	stab	hm2data0
	stab	hm2data1
	ldib	0FFh
	stab	hm2data2
	ldib	007h
	stab	hm2data3
	ldib	000h
	stab	hm2addr0
	ldib	011h
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	012h		; do the same for alt src regs		
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	0FFh
	stab	hm2data0
	ldib	0F7h
	stab	hm2data1
	ldib	001h
	stab	hm2data2
	ldib	000h
	stab	hm2data3
	ldib	004h
	stab	hm2addr0
	ldib	011h
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ldib	012h		; do the same for alt src regs		
	stab	hm2addr1
	nop
	stab	hm2startwrite
	nop
	nop
	nop
	nop
	ret
	
#include ssinit.asm
#include ssparse.asm
#include ssdebug.asm
#include serfls.asm
	
	org	0fffh
	dw	0abcdh	
.end