
;TYPES (contents of ram address)
;	<blank>	number of bits is hardware dependent	
;	ptr	10 bit address pointer
;	flag	16 bit value 0 is false, nonzero is true
;	uint	16 bit unsigned value 0..65535
;	int	16 bit signed value -32768..32767
;	ulong	32 bit unsigned value 0..4294967295
;	long	32 bit signed value -2147483648..2147483647
;	double	64 bit signed value -1.8E19..1.8E19

;PARAMETER	VALUE	TYPE	FUNCTION
rambegin	128          
ramend		2047

lbplocalmem	128	%ptr
lbpunitadd	128	%ptr	; C0 this space is special as its mapped	
lbpstatus	129	%ptr	; C1 into LBP local variable space
lbpcrcen	130	%ptr	; C2
lbpcrcerrcnt	131	%ptr	; C3
lbpres_C4	132	%ptr	; C4	
lbpres_C5	133	%ptr	; C5	
lbpremswmode	134	%ptr	; C6	
lbpclrremflt	135	%ptr	; C7	
lbpres_C8	136	%ptr	; C8	
lbpres_C9	137	%ptr	; C9	
lbpenarpcacc	138	%ptr	; CA 
lbpcommandto	139	%ptr	; CB
lbpmemspace	140	%ptr	; CC
lbpres_CD	141	%ptr	; CD
lbpres_CE	142	%ptr	; CE
lbpres_CF	143	%ptr	; CF
lbpcardname0	144	%ptr	; D0 (DX is read only excpept as noted)
lbpcardname1	145	%ptr	; D1
lbpcardname2	146	%ptr	; D2
lbpcardname3	147	%ptr	; D3
lbpcapability	148	%ptr	; D4
lbpremver	149	%ptr	; D5
lbpremhwmode	150	%ptr	; D6
lbpleds		151	%ptr	; D7 (leds on write) 
lbpremfault	151	%ptr	; D7 (remote fault on reads)
lbpaddrlow	152	%ptr	; D8 (read/write)
lbpaddrhigh	153	%ptr	; D9 (read/write)
lbpaddrinc	154	%ptr	; DA (writes)
lbpversion	154	%ptr	; DA (reads)
lbpsetunitid	155	%ptr	; DB
lbprpcpitch	156	%ptr	; DC
lbprpcsizelow	157	%ptr	; DD
lbprpcsizehigh	158	%ptr	; DE
lbpcookie	159	%ptr	; DF

null		192	%ptr	uninitialized pointers point to dummy
zeroloc		193	%ptr	
oneloc		194	%ptr	
twoloc		195	%ptr
minusoneloc	196	%ptr
loopiloc	197	%ptr
temp		198
rxpktsize	199	%ptr
txpktsize	200	%ptr

lbpcommand	201	%ptr
lbpcomonly	202	%ptr
lbprwsize	203	%ptr
lbpextmem	204	%ptr
txptrmask	205	%ptr
rxpktcount	206	%ptr
lbplocalmemptr	207	%ptr

rpctxsize	208	%ptr	bytes of process data we send
rpcrxsize	209	%ptr	bytes of process data we recv
rpcgtoc		210	%ptr	global TOC
rpcptoc		212	%ptr	process TOC
rpcunitnumber	214	%ptr	4 byte unit number

parsegoodtime	218	%ptr	word for watchdog timer etc
greencount	220	%ptr	
wdtimeout	222	%ptr
rxbuffer	256	%ptr
txbuffer	384	%ptr

m0ptoc0		512	%ptr	32 per PTOC/GTOC
m0gtoc0		544	%ptr
m1ptoc0		576	%ptr	
m1gtoc0		608	%ptr
hwmode0		640	%ptr	16 per mode record
hwmode1		656	%ptr
swmode0		672	%ptr
swmode1		688	%ptr
m0pdd0		704	%ptr	32 per process record
m0pdd1		736	%ptr
m0pdd2		768	%ptr
m0pdd3		800	%ptr
m0pdd4		832	%ptr
m0pdd5		864	%ptr
m0pdd6		896	%ptr
m0pdd7		928	%ptr
m0pdd8		960	%ptr
m0pdd9		992	%ptr
m1pdd0		1024	%ptr
m1pdd1		1056	%ptr
m1pdd2		1088	%ptr
m1pdd3		1120	%ptr
m1pdd4		1152	%ptr
m1pdd5		1184	%ptr
m1pdd6		1216	%ptr
m1pdd7		1248	%ptr
m1pdd8		1280	%ptr
m1pdd9		1312	%ptr
m0gdd0		1344	%ptr	32 per global record
m0gdd1		1376	%ptr
m0gdd2		1408	%ptr
m0gdd3		1440	%ptr
m0gdd4		1472	%ptr
m0gdd5		1504	%ptr
m0gdd6		1536	%ptr
m0gdd7		1568	%ptr
m1gdd0		1600	%ptr
m1gdd1		1632	%ptr
m1gdd2		1664	%ptr
m1gdd3		1696	%ptr
m1gdd4		1728	%ptr
m1gdd5		1760	%ptr
m1gdd6		1792	%ptr
m1gdd7		1824	%ptr

; Transfer buffer locs, 16 bytes each
inputbits	1920	%ptr
encoder0	1926	%ptr
encoder1	1927	%ptr
encoder2	1928	%ptr
encoder3	1929	%ptr
enc0mode	1930	%ptr
enc1mode	1931	%ptr ; encmodes must be sequential
enc2mode	1932	%ptr ; ""
enc3mode	1933	%ptr ; ""
hm2input0	1935	%ptr
hm2input1	1938	%ptr
hm2input2	1942	%ptr
hm2output0	1945	%ptr
hm2output1	1948	%ptr
hm2output2	1951	%ptr
swrevision      1954    %ptr ; ""
hwrevision      1955    %ptr ; must follow swrevision
freemem		1956    %ptr

majorrev	1		updated when parameters change, hi byte
minorrev	0		lo byte
	
ddbittype		001h		data descriptor = bits
ddunsignedtype		002h
ddsignedtype		003h
ddnvunsignedtype	004h
ddnvsignedtype		005h
ddstreamtype		006h
ddbooleantype		007h
ddcounttype		008h
dddirectionin		000h
dddirectionout		080h
dddirboth		040h
defaultwdtime	193		; in 256 usec increments

lbpcommask	0C0h
lbpautoincmask	008h
lbpaddrszmask	004h
lbpwritemask	020h
lbpsizemask	003h
lbprwcom	040h
lbprpc		080h
lbplocal	0C0h
lbplocaladdmask	01Fh
lbpsize8	000h
lbpsize16	001h
lbpsize32	002h
lbpsize64	003h
lbplocalro	010h

lbpsetclrfltcom		0E7h
lbpsetcomtocom		0EBh
lbpextmemcode		0EEh
lbpsetledscom		0F7h
lbpsetaddrlowcom	0F8h
lbpsetaddrhighcom	0F9h
lbpincaddrcom		0FAh
lbpresetproccom		0FEh
lbpresetparsercom	0FFh

;lbp error bits in lbp status register
lbpcrcerrb	001h
lbpwdtoerrb	008h
lbpbufferrb	010h
lbpinvalidaddrb	020h		


;remote fault bits
remwdfault	001h
	
processdatarpc		BDh	%const	send/return process data
unitnumberrpc		BCh	%const	returns unitnumber
discoveryrpc		BBh	%const	returns discovery

;hardware

timerlow	020h	%ptr	low byte of timer (default 1 MHz count rate)
timerhigh	021h	%ptr	high byte of timer

crc		022h	%ptr	write data to check, read CRC
clrcrc		023h	%ptr	write to clear crc

pktrxdata	028h	%ptr	uartrx data buffer
pktrxdatacnt	029h	%ptr	uartrx frame count
pktrxratel	02Ah	%ptr	uartrx bit rate low
pktrxratem	02Bh	%ptr	uartrx bit rate med
pktrxrateh	02Ch	%ptr	uartrx bit rate high
pktrxmode	02Dh	%ptr	uartrx mode register
pktrxframeto	02Eh	%ptr	uartrx frame time out
pktrxstatus	02Fh	%ptr	uartrx status register
pkttxdata	030h	%ptr	uarttx data buffer
pkttxdatacnt	031h	%ptr	uarttx frame count
pkttxratel	032h	%ptr	uarttx bit rate low
pkttxratem	033h	%ptr	uarttx bit rate med
pkttxrateh	034h	%ptr	uarttx bit rate high
pkttxmode	035h	%ptr	uarttx mode register
pkttxframeto	036h	%ptr	uarttx frame time out
pkttxstatus	037h	%ptr	uarttx status register
settpreg0	03Ch	%ptr
clrtpreg0	03Dh	%ptr
settpreg1	03Eh	%ptr
clrtpreg1	03Fh	%ptr

readopts	03Fh	%ptr	read options here

defaulthsbrl	040h	%ptr	low byte of default high speed baudrate
defaulthsbrm	041h	%ptr	mid byte of default high speed baudrate
defaulthsbrh	042h	%ptr	high byte of default high speed baudrate

defaultlsbrl	043h	%ptr	low byte of default low speed baudrate
defaultlsbrm	044h	%ptr	mid byte of default low speed baudrate
defaultlsbrh	045h	%ptr	high byte of default low speed baudrate

hm2data0	060h	%ptr	Hostmot2 data read and written here
hm2data1	061h	%ptr	Hostmot2 data read and written here
hm2data2	062h	%ptr	Hostmot2 data read and written here
hm2data3	063h	%ptr	Hostmot2 data read and written here
hm2addr0	068h	%ptr	Hostmot2 address written here
hm2addr1	069h	%ptr
hm2startread	06Ch	%ptr	writes here start a read cycle
hm2startwrite	06Dh	%ptr	writes here start a write cycle
hm2incaddr	06Eh	%ptr	writes here increment the address 

readrates	070h	%ptr

errorled	079h	%ptr
localleds	07Ah	%ptr
localledmode	07Bh	%ptr

fpgaspics	07Dh	%ptr
fpgaspidata	07Eh	%ptr

reconfig	07Fh	%ptr	writes here cause a reconfig



